import { defineComponent as bt, ref as ue, onMounted as yt, onBeforeUnmount as zt, computed as z, openBlock as L, createElementBlock as M, normalizeClass as q, normalizeStyle as ze, createElementVNode as f, Fragment as ne, renderList as oe, toDisplayString as we, renderSlot as hn, createTextVNode as lt, h as Xn, resolveComponent as Xo, useCssVars as qo, useSlots as Go, toRefs as go, watch as vt, watchEffect as qn, unref as ee, withKeys as Jo, createVNode as Ue, Transition as Ko, withCtx as Ft, withDirectives as fe, createBlock as Qo, createCommentVNode as Tn, vShow as bo, reactive as Zo, nextTick as yo, isRef as er, vModelText as ke, pushScopeId as En, popScopeId as Sn, withModifiers as tr, vModelSelect as Gn } from "vue";
var P = /* @__PURE__ */ ((t) => (t.DATA = "DATA", t.SYMBOL = "SYMBOL", t.ACTION = "ACTION", t.ICON = "ICON", t.LABEL = "LABEL", t))(P || {});
const mn = [
  {
    vfTitle: "⌴",
    vfCode: "space",
    vfType: P.SYMBOL,
    vfAcutalField: "space",
    vfActualFieldTitle: "Dấu cách",
    value: "&nbsp;"
  },
  {
    vfTitle: "↩",
    vfCode: "newline",
    vfType: P.SYMBOL,
    vfAcutalField: "newline",
    vfActualFieldTitle: "NewLine",
    value: "<br/>"
  },
  {
    vfTitle: "-",
    vfCode: "minus",
    vfType: P.SYMBOL,
    vfAcutalField: "minus",
    vfActualFieldTitle: "Dấu trừ",
    value: "&hyphen;"
  },
  {
    vfTitle: "_",
    vfCode: "underscore",
    vfType: P.SYMBOL,
    vfAcutalField: "underscore",
    vfActualFieldTitle: "Dấu gạch dưới",
    value: "_"
  },
  {
    vfTitle: "|",
    vfCode: "vertical",
    vfType: P.SYMBOL,
    vfAcutalField: "vertical",
    vfActualFieldTitle: "Dấu dọc",
    value: "|"
  },
  {
    vfTitle: ",",
    vfCode: "comma",
    vfType: P.SYMBOL,
    vfAcutalField: "comma",
    vfActualFieldTitle: "Dấu phẩy",
    value: ","
  },
  {
    vfTitle: ":",
    vfCode: "colon",
    vfType: P.SYMBOL,
    vfAcutalField: "colon",
    vfActualFieldTitle: "Hai chấm",
    value: ":"
  },
  {
    vfTitle: ".",
    vfCode: "dot",
    vfType: P.SYMBOL,
    vfAcutalField: "dot",
    vfActualFieldTitle: "Dấu chấm",
    value: "."
  },
  {
    vfTitle: ";",
    vfCode: "semicolon",
    vfType: P.SYMBOL,
    vfAcutalField: "semicolon",
    vfActualFieldTitle: "Chấm phẩy",
    value: ";"
  },
  {
    vfTitle: "/",
    vfCode: "slash",
    vfType: P.SYMBOL,
    vfAcutalField: "slash",
    vfActualFieldTitle: "Dấu gạch chéo",
    value: "/"
  },
  {
    vfTitle: "\\",
    vfCode: "backslash",
    vfType: P.SYMBOL,
    vfAcutalField: "backslash",
    vfActualFieldTitle: "Dấu gạch chéo ngược",
    value: "\\"
  },
  {
    vfTitle: "?",
    vfCode: "question",
    vfType: P.SYMBOL,
    vfAcutalField: "question",
    vfActualFieldTitle: "Dấu hỏi",
    value: "?"
  },
  {
    vfTitle: "~",
    vfCode: "tilde",
    vfType: P.SYMBOL,
    vfAcutalField: "tilde",
    vfActualFieldTitle: "Dấu ngã",
    value: "~"
  },
  {
    vfTitle: "@",
    vfCode: "at",
    vfType: P.SYMBOL,
    vfAcutalField: "at",
    vfActualFieldTitle: "Dấu @",
    value: "@"
  },
  {
    vfTitle: "#",
    vfCode: "hash",
    vfType: P.SYMBOL,
    vfAcutalField: "hash",
    vfActualFieldTitle: "Dấu #",
    value: "#"
  },
  {
    vfTitle: "$",
    vfCode: "dollar",
    vfType: P.SYMBOL,
    vfAcutalField: "dollar",
    vfActualFieldTitle: "Dấu $",
    value: "$"
  },
  {
    vfTitle: "^",
    vfCode: "caret",
    vfType: P.SYMBOL,
    vfAcutalField: "caret",
    vfActualFieldTitle: "Dấu mũ",
    value: "^"
  },
  {
    vfTitle: "&",
    vfCode: "ampersand",
    vfType: P.SYMBOL,
    vfAcutalField: "ampersand",
    vfActualFieldTitle: "Dấu &",
    value: "&"
  },
  {
    vfTitle: "*",
    vfCode: "asterisk",
    vfType: P.SYMBOL,
    vfAcutalField: "asterisk",
    vfActualFieldTitle: "Dấu *",
    value: "*"
  },
  {
    vfTitle: "[",
    vfCode: "openBracket",
    vfType: P.SYMBOL,
    vfAcutalField: "openBracket",
    vfActualFieldTitle: "Mở ngoặc vuông",
    value: "["
  },
  {
    vfTitle: "]",
    vfCode: "closeBracket",
    vfType: P.SYMBOL,
    vfAcutalField: "closeBracket",
    vfActualFieldTitle: "Đóng ngoặc vuông",
    value: "]"
  },
  {
    vfTitle: "(",
    vfCode: "openRoundBracket",
    vfType: P.SYMBOL,
    vfAcutalField: "openRoundBracket",
    vfActualFieldTitle: "Mở ngoặc tròn",
    value: "("
  },
  {
    vfTitle: ")",
    vfCode: "closeRoundBracket",
    vfType: P.SYMBOL,
    vfAcutalField: "closeRoundBracket",
    vfActualFieldTitle: "Đóng hoặc tròn",
    value: ")"
  },
  {
    vfTitle: "<",
    vfCode: "openAngleBracket",
    vfType: P.SYMBOL,
    vfAcutalField: "openAngleBracket",
    vfActualFieldTitle: "Mở ngoặc nhọn",
    value: "<"
  },
  {
    vfTitle: ">",
    vfCode: "closeAngleBracket",
    vfType: P.SYMBOL,
    vfAcutalField: "closeAngleBracket",
    vfActualFieldTitle: "Đóng ngoặc nhọn",
    value: ">"
  },
  {
    vfTitle: '"',
    vfCode: "doubleQuote",
    vfType: P.SYMBOL,
    vfAcutalField: "doubleQuote",
    vfActualFieldTitle: "Dấu ngoặc kép",
    value: '"'
  },
  {
    vfTitle: "'",
    vfCode: "singleQuote",
    vfType: P.SYMBOL,
    vfAcutalField: "singleQuote",
    vfActualFieldTitle: "Dấu ngoặc đơn",
    value: "'"
  },
  {
    vfTitle: "`",
    vfCode: "backtick",
    vfType: P.SYMBOL,
    vfAcutalField: "backtick",
    vfActualFieldTitle: "Dấu ngoặc ngược",
    value: "`"
  }
];
P.ACTION, P.ACTION, P.ACTION;
function nr(t) {
  return t && t.__esModule && Object.prototype.hasOwnProperty.call(t, "default") ? t.default : t;
}
/*!
 * escape-html
 * Copyright(c) 2012-2013 TJ Holowaychuk
 * Copyright(c) 2015 Andreas Lubbe
 * Copyright(c) 2015 Tiancheng "Timothy" Gu
 * MIT Licensed
 */
var or = /["'&<>]/, rr = ir;
function ir(t) {
  var e = "" + t, n = or.exec(e);
  if (!n)
    return e;
  var o, r = "", i = 0, a = 0;
  for (i = n.index; i < e.length; i++) {
    switch (e.charCodeAt(i)) {
      case 34:
        o = "&quot;";
        break;
      case 38:
        o = "&amp;";
        break;
      case 39:
        o = "&#39;";
        break;
      case 60:
        o = "&lt;";
        break;
      case 62:
        o = "&gt;";
        break;
      default:
        continue;
    }
    a !== i && (r += e.substring(a, i)), a = i + 1, r += o;
  }
  return a !== i ? r + e.substring(a, i) : r;
}
const Zt = /* @__PURE__ */ nr(rr), ar = { class: "dynamic-table" }, lr = ["innerHTML"], sr = { key: 1 }, ur = ["colspan"], cr = "tdac", dr = /* @__PURE__ */ bt({
  __name: "DynamicTable",
  props: {
    columns: { default: () => [] },
    templates: { default: () => [] },
    labels: { default: () => [] },
    data: { default: () => [] },
    height: {},
    fixed: { type: Boolean, default: !1 }
  },
  emits: ["onCta"],
  setup(t, { emit: e }) {
    const n = t, o = e, r = ue("");
    yt(() => {
      r.value = `${cr}${Math.floor(Math.random() * 1e6)}`;
      const u = window;
      u[r.value] = function(y, b) {
        const p = n.data[b];
        p && o("onCta", y, p, b);
      };
    }), zt(() => {
      const u = window;
      u[r.value] && (u[r.value] = void 0, delete u[r.value]);
    });
    const i = z(() => (u, y = "", b = {}) => {
      for (const p in u)
        if (u.hasOwnProperty(p)) {
          const h = y ? `${y}.${p}` : p;
          typeof u[p] == "object" && u[p] !== null ? i.value(u[p], h, b) : b[h] = u[p];
        }
      return b;
    }), a = (u, y) => u.replace(/\{\{(.*?)\}\}/g, (b, p) => {
      const h = y[p];
      return h ?? b;
    }), l = z(() => (u) => {
      const y = {
        "text-align": u.align || "left",
        "vertical-align": u.vAlign || "top"
      };
      return u.width && (y.width = u.width), u.minWidth && (y["min-width"] = u.minWidth), u.maxWidth && (y["max-width"] = u.maxWidth), y;
    }), s = z(() => [
      ...n.templates,
      ...n.labels.map((u) => ({
        vfTitle: u.title,
        vfCode: u.code,
        vfType: P.LABEL,
        meta: u.style
      })),
      ...mn
    ].reduce((u, y) => (u[y.vfCode] = y, u), {})), c = z(() => (u) => {
      const y = n.labels.find((h) => h.code === u.vfCode), b = (y == null ? void 0 : y.style) || {}, p = Object.entries(b).map(([h, m]) => `${h.replace(/[A-Z]/g, (E) => `-${E.toLowerCase()}`)}: ${m}`);
      return b.backgroundColor && b.backgroundColor !== "transparent" && (p.push("padding: 0 3px"), p.push("border-radius: 3px")), p.join(";");
    }), d = z(() => (u, y, b) => {
      const p = [];
      for (const h of y.fieldCodes) {
        const m = s.value[h];
        if (m)
          switch (m.vfType) {
            case P.SYMBOL:
              p.push((m == null ? void 0 : m.value) || "");
              break;
            case P.ACTION:
              if (m.vfRenderFunc) {
                const g = m.vfRenderFunc(u, m, b, r.value), C = document.createElement("span");
                C.classList.add("btn"), C.classList.add(`btn-${m.vfCode}`), C.setAttribute("onClick", `${r.value}('${m.vfCode}', ${b})`), C.textContent = g, p.push(C.outerHTML);
                break;
              }
              if (m.vfAcutalField) {
                const C = i.value(u)[(m == null ? void 0 : m.vfAcutalField) || ""], v = document.createElement("span");
                v.classList.add("btn"), v.classList.add(`btn-${m.vfCode}`), v.setAttribute("onClick", `${r.value}('${m.vfCode}', ${b})`), v.textContent = C || "", p.push(v.outerHTML);
                break;
              }
              const T = document.createElement("span");
              T.classList.add("btn"), T.classList.add(`btn-${m.vfCode}`), T.setAttribute("onClick", `${r.value}('${m.vfCode}', ${b})`), T.textContent = (m == null ? void 0 : m.vfTitle) || "", p.push(T.outerHTML);
              break;
            case P.ICON:
              const E = document.createElement("img");
              E.classList.add("icon"), E.src = m.value || "", p.push(E.outerHTML);
              break;
            case P.LABEL:
              const w = document.createElement("span");
              w.style.cssText = c.value(m), w.textContent = m.vfTitle, p.push(w.outerHTML);
              break;
            default:
              let S = i.value(u)[(m == null ? void 0 : m.vfAcutalField) || ""];
              if (m.vfRenderFunc) {
                const g = m.vfRenderFunc(u, m, b, r.value, structuredClone(S));
                p.push(g);
                break;
              }
              const k = u[m.vfAcutalField];
              if (Array.isArray(k)) {
                const g = m.templateShow ? k.map((C) => a(m.templateShow, { $item: Zt(C) })).join("") : k.join(", ");
                p.push(g);
                break;
              }
              m != null && m.enum && Object.keys(m.enum).length > 0 && (S = m.enum[S] || S, S = Zt(S)), m != null && m.templateShow && (S = a(m == null ? void 0 : m.templateShow, { value: Zt(S) })), p.push(S);
              break;
          }
      }
      return p.join("");
    });
    return (u, y) => {
      var b;
      return L(), M("div", {
        class: q(["wrapper-table custom-scroll", { fixed: u.fixed }]),
        style: ze({ height: u.fixed ? `${u.height}px` : "auto" })
      }, [
        f("table", ar, [
          f("thead", null, [
            f("tr", null, [
              (L(!0), M(ne, null, oe(u.columns, (p, h) => (L(), M("th", {
                key: h,
                class: q({ "drag-over": p.isDrag })
              }, we(p.title), 3))), 128))
            ])
          ]),
          f("tbody", null, [
            (((b = u.data) == null ? void 0 : b.length) || 0) > 0 ? (L(!0), M(ne, { key: 0 }, oe(u.data, (p, h) => (L(), M("tr", { key: h }, [
              (L(!0), M(ne, null, oe(u.columns, (m, T) => (L(), M("td", {
                key: T,
                class: q({ "drag-over": m.isDrag }),
                style: ze(l.value(m))
              }, [
                f("div", {
                  class: "td-line",
                  innerHTML: d.value(p, m, h)
                }, null, 8, lr)
              ], 6))), 128))
            ]))), 128)) : (L(), M("tr", sr, [
              f("td", {
                colspan: u.columns.length,
                class: "no-data"
              }, [
                hn(u.$slots, "no-data", {}, () => [
                  lt(" Không có dữ liệu ")
                ], !0)
              ], 8, ur)
            ]))
          ])
        ])
      ], 6);
    };
  }
}), Xt = (t, e) => {
  const n = t.__vccOpts || t;
  for (const [o, r] of e)
    n[o] = r;
  return n;
}, Jn = /* @__PURE__ */ Xt(dr, [["__scopeId", "data-v-e0be3805"]]);
/*!
  * vue-draggable-next v2.2.0
  * (c) 2023 Anish George
  * @license MIT
  */
/**!
 * Sortable 1.14.0
 * @author	RubaXa   <trash@rubaxa.org>
 * @author	owenm    <owen23355@gmail.com>
 * @license MIT
 */
function Kn(t, e) {
  var n = Object.keys(t);
  if (Object.getOwnPropertySymbols) {
    var o = Object.getOwnPropertySymbols(t);
    e && (o = o.filter(function(r) {
      return Object.getOwnPropertyDescriptor(t, r).enumerable;
    })), n.push.apply(n, o);
  }
  return n;
}
function Oe(t) {
  for (var e = 1; e < arguments.length; e++) {
    var n = arguments[e] != null ? arguments[e] : {};
    e % 2 ? Kn(Object(n), !0).forEach(function(o) {
      fr(t, o, n[o]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(t, Object.getOwnPropertyDescriptors(n)) : Kn(Object(n)).forEach(function(o) {
      Object.defineProperty(t, o, Object.getOwnPropertyDescriptor(n, o));
    });
  }
  return t;
}
function Lt(t) {
  "@babel/helpers - typeof";
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? Lt = function(e) {
    return typeof e;
  } : Lt = function(e) {
    return e && typeof Symbol == "function" && e.constructor === Symbol && e !== Symbol.prototype ? "symbol" : typeof e;
  }, Lt(t);
}
function fr(t, e, n) {
  return e in t ? Object.defineProperty(t, e, {
    value: n,
    enumerable: !0,
    configurable: !0,
    writable: !0
  }) : t[e] = n, t;
}
function Ie() {
  return Ie = Object.assign || function(t) {
    for (var e = 1; e < arguments.length; e++) {
      var n = arguments[e];
      for (var o in n)
        Object.prototype.hasOwnProperty.call(n, o) && (t[o] = n[o]);
    }
    return t;
  }, Ie.apply(this, arguments);
}
function pr(t, e) {
  if (t == null)
    return {};
  var n = {}, o = Object.keys(t), r, i;
  for (i = 0; i < o.length; i++)
    r = o[i], !(e.indexOf(r) >= 0) && (n[r] = t[r]);
  return n;
}
function vr(t, e) {
  if (t == null)
    return {};
  var n = pr(t, e), o, r;
  if (Object.getOwnPropertySymbols) {
    var i = Object.getOwnPropertySymbols(t);
    for (r = 0; r < i.length; r++)
      o = i[r], !(e.indexOf(o) >= 0) && Object.prototype.propertyIsEnumerable.call(t, o) && (n[o] = t[o]);
  }
  return n;
}
var hr = "1.14.0";
function $e(t) {
  if (typeof window < "u" && window.navigator)
    return !!/* @__PURE__ */ navigator.userAgent.match(t);
}
var Le = $e(/(?:Trident.*rv[ :]?11\.|msie|iemobile|Windows Phone)/i), wt = $e(/Edge/i), Qn = $e(/firefox/i), st = $e(/safari/i) && !$e(/chrome/i) && !$e(/android/i), wo = $e(/iP(ad|od|hone)/i), mr = $e(/chrome/i) && $e(/android/i), _o = {
  capture: !1,
  passive: !1
};
function N(t, e, n) {
  t.addEventListener(e, n, !Le && _o);
}
function B(t, e, n) {
  t.removeEventListener(e, n, !Le && _o);
}
function jt(t, e) {
  if (e) {
    if (e[0] === ">" && (e = e.substring(1)), t)
      try {
        if (t.matches)
          return t.matches(e);
        if (t.msMatchesSelector)
          return t.msMatchesSelector(e);
        if (t.webkitMatchesSelector)
          return t.webkitMatchesSelector(e);
      } catch {
        return !1;
      }
    return !1;
  }
}
function gr(t) {
  return t.host && t !== document && t.host.nodeType ? t.host : t.parentNode;
}
function Te(t, e, n, o) {
  if (t) {
    n = n || document;
    do {
      if (e != null && (e[0] === ">" ? t.parentNode === n && jt(t, e) : jt(t, e)) || o && t === n)
        return t;
      if (t === n)
        break;
    } while (t = gr(t));
  }
  return null;
}
var Zn = /\s+/g;
function ce(t, e, n) {
  if (t && e)
    if (t.classList)
      t.classList[n ? "add" : "remove"](e);
    else {
      var o = (" " + t.className + " ").replace(Zn, " ").replace(" " + e + " ", " ");
      t.className = (o + (n ? " " + e : "")).replace(Zn, " ");
    }
}
function $(t, e, n) {
  var o = t && t.style;
  if (o) {
    if (n === void 0)
      return document.defaultView && document.defaultView.getComputedStyle ? n = document.defaultView.getComputedStyle(t, "") : t.currentStyle && (n = t.currentStyle), e === void 0 ? n : n[e];
    !(e in o) && e.indexOf("webkit") === -1 && (e = "-webkit-" + e), o[e] = n + (typeof n == "string" ? "" : "px");
  }
}
function Qe(t, e) {
  var n = "";
  if (typeof t == "string")
    n = t;
  else
    do {
      var o = $(t, "transform");
      o && o !== "none" && (n = o + " " + n);
    } while (!e && (t = t.parentNode));
  var r = window.DOMMatrix || window.WebKitCSSMatrix || window.CSSMatrix || window.MSCSSMatrix;
  return r && new r(n);
}
function Co(t, e, n) {
  if (t) {
    var o = t.getElementsByTagName(e), r = 0, i = o.length;
    if (n)
      for (; r < i; r++)
        n(o[r], r);
    return o;
  }
  return [];
}
function Ee() {
  var t = document.scrollingElement;
  return t || document.documentElement;
}
function G(t, e, n, o, r) {
  if (!(!t.getBoundingClientRect && t !== window)) {
    var i, a, l, s, c, d, u;
    if (t !== window && t.parentNode && t !== Ee() ? (i = t.getBoundingClientRect(), a = i.top, l = i.left, s = i.bottom, c = i.right, d = i.height, u = i.width) : (a = 0, l = 0, s = window.innerHeight, c = window.innerWidth, d = window.innerHeight, u = window.innerWidth), (e || n) && t !== window && (r = r || t.parentNode, !Le))
      do
        if (r && r.getBoundingClientRect && ($(r, "transform") !== "none" || n && $(r, "position") !== "static")) {
          var y = r.getBoundingClientRect();
          a -= y.top + parseInt($(r, "border-top-width")), l -= y.left + parseInt($(r, "border-left-width")), s = a + i.height, c = l + i.width;
          break;
        }
      while (r = r.parentNode);
    if (o && t !== window) {
      var b = Qe(r || t), p = b && b.a, h = b && b.d;
      b && (a /= h, l /= p, u /= p, d /= h, s = a + d, c = l + u);
    }
    return {
      top: a,
      left: l,
      bottom: s,
      right: c,
      width: u,
      height: d
    };
  }
}
function eo(t, e, n) {
  for (var o = Ne(t, !0), r = G(t)[e]; o; ) {
    var i = G(o)[n], a = void 0;
    if (n === "top" || n === "left" ? a = r >= i : a = r <= i, !a)
      return o;
    if (o === Ee())
      break;
    o = Ne(o, !1);
  }
  return !1;
}
function Ze(t, e, n, o) {
  for (var r = 0, i = 0, a = t.children; i < a.length; ) {
    if (a[i].style.display !== "none" && a[i] !== I.ghost && (o || a[i] !== I.dragged) && Te(a[i], n.draggable, t, !1)) {
      if (r === e)
        return a[i];
      r++;
    }
    i++;
  }
  return null;
}
function On(t, e) {
  for (var n = t.lastElementChild; n && (n === I.ghost || $(n, "display") === "none" || e && !jt(n, e)); )
    n = n.previousElementSibling;
  return n || null;
}
function he(t, e) {
  var n = 0;
  if (!t || !t.parentNode)
    return -1;
  for (; t = t.previousElementSibling; )
    t.nodeName.toUpperCase() !== "TEMPLATE" && t !== I.clone && (!e || jt(t, e)) && n++;
  return n;
}
function to(t) {
  var e = 0, n = 0, o = Ee();
  if (t)
    do {
      var r = Qe(t), i = r.a, a = r.d;
      e += t.scrollLeft * i, n += t.scrollTop * a;
    } while (t !== o && (t = t.parentNode));
  return [e, n];
}
function br(t, e) {
  for (var n in t)
    if (t.hasOwnProperty(n)) {
      for (var o in e)
        if (e.hasOwnProperty(o) && e[o] === t[n][o])
          return Number(n);
    }
  return -1;
}
function Ne(t, e) {
  if (!t || !t.getBoundingClientRect)
    return Ee();
  var n = t, o = !1;
  do
    if (n.clientWidth < n.scrollWidth || n.clientHeight < n.scrollHeight) {
      var r = $(n);
      if (n.clientWidth < n.scrollWidth && (r.overflowX == "auto" || r.overflowX == "scroll") || n.clientHeight < n.scrollHeight && (r.overflowY == "auto" || r.overflowY == "scroll")) {
        if (!n.getBoundingClientRect || n === document.body)
          return Ee();
        if (o || e)
          return n;
        o = !0;
      }
    }
  while (n = n.parentNode);
  return Ee();
}
function yr(t, e) {
  if (t && e)
    for (var n in e)
      e.hasOwnProperty(n) && (t[n] = e[n]);
  return t;
}
function en(t, e) {
  return Math.round(t.top) === Math.round(e.top) && Math.round(t.left) === Math.round(e.left) && Math.round(t.height) === Math.round(e.height) && Math.round(t.width) === Math.round(e.width);
}
var ut;
function Do(t, e) {
  return function() {
    if (!ut) {
      var n = arguments, o = this;
      n.length === 1 ? t.call(o, n[0]) : t.apply(o, n), ut = setTimeout(function() {
        ut = void 0;
      }, e);
    }
  };
}
function wr() {
  clearTimeout(ut), ut = void 0;
}
function xo(t, e, n) {
  t.scrollLeft += e, t.scrollTop += n;
}
function To(t) {
  var e = window.Polymer, n = window.jQuery || window.Zepto;
  return e && e.dom ? e.dom(t).cloneNode(!0) : n ? n(t).clone(!0)[0] : t.cloneNode(!0);
}
var pe = "Sortable" + (/* @__PURE__ */ new Date()).getTime();
function _r() {
  var t = [], e;
  return {
    captureAnimationState: function() {
      if (t = [], !!this.options.animation) {
        var o = [].slice.call(this.el.children);
        o.forEach(function(r) {
          if (!($(r, "display") === "none" || r === I.ghost)) {
            t.push({
              target: r,
              rect: G(r)
            });
            var i = Oe({}, t[t.length - 1].rect);
            if (r.thisAnimationDuration) {
              var a = Qe(r, !0);
              a && (i.top -= a.f, i.left -= a.e);
            }
            r.fromRect = i;
          }
        });
      }
    },
    addAnimationState: function(o) {
      t.push(o);
    },
    removeAnimationState: function(o) {
      t.splice(br(t, {
        target: o
      }), 1);
    },
    animateAll: function(o) {
      var r = this;
      if (!this.options.animation) {
        clearTimeout(e), typeof o == "function" && o();
        return;
      }
      var i = !1, a = 0;
      t.forEach(function(l) {
        var s = 0, c = l.target, d = c.fromRect, u = G(c), y = c.prevFromRect, b = c.prevToRect, p = l.rect, h = Qe(c, !0);
        h && (u.top -= h.f, u.left -= h.e), c.toRect = u, c.thisAnimationDuration && en(y, u) && !en(d, u) && // Make sure animatingRect is on line between toRect & fromRect
        (p.top - u.top) / (p.left - u.left) === (d.top - u.top) / (d.left - u.left) && (s = Dr(p, y, b, r.options)), en(u, d) || (c.prevFromRect = d, c.prevToRect = u, s || (s = r.options.animation), r.animate(c, p, u, s)), s && (i = !0, a = Math.max(a, s), clearTimeout(c.animationResetTimer), c.animationResetTimer = setTimeout(function() {
          c.animationTime = 0, c.prevFromRect = null, c.fromRect = null, c.prevToRect = null, c.thisAnimationDuration = null;
        }, s), c.thisAnimationDuration = s);
      }), clearTimeout(e), i ? e = setTimeout(function() {
        typeof o == "function" && o();
      }, a) : typeof o == "function" && o(), t = [];
    },
    animate: function(o, r, i, a) {
      if (a) {
        $(o, "transition", ""), $(o, "transform", "");
        var l = Qe(this.el), s = l && l.a, c = l && l.d, d = (r.left - i.left) / (s || 1), u = (r.top - i.top) / (c || 1);
        o.animatingX = !!d, o.animatingY = !!u, $(o, "transform", "translate3d(" + d + "px," + u + "px,0)"), this.forRepaintDummy = Cr(o), $(o, "transition", "transform " + a + "ms" + (this.options.easing ? " " + this.options.easing : "")), $(o, "transform", "translate3d(0,0,0)"), typeof o.animated == "number" && clearTimeout(o.animated), o.animated = setTimeout(function() {
          $(o, "transition", ""), $(o, "transform", ""), o.animated = !1, o.animatingX = !1, o.animatingY = !1;
        }, a);
      }
    }
  };
}
function Cr(t) {
  return t.offsetWidth;
}
function Dr(t, e, n, o) {
  return Math.sqrt(Math.pow(e.top - t.top, 2) + Math.pow(e.left - t.left, 2)) / Math.sqrt(Math.pow(e.top - n.top, 2) + Math.pow(e.left - n.left, 2)) * o.animation;
}
var qe = [], tn = {
  initializeByDefault: !0
}, _t = {
  mount: function(e) {
    for (var n in tn)
      tn.hasOwnProperty(n) && !(n in e) && (e[n] = tn[n]);
    qe.forEach(function(o) {
      if (o.pluginName === e.pluginName)
        throw "Sortable: Cannot mount plugin ".concat(e.pluginName, " more than once");
    }), qe.push(e);
  },
  pluginEvent: function(e, n, o) {
    var r = this;
    this.eventCanceled = !1, o.cancel = function() {
      r.eventCanceled = !0;
    };
    var i = e + "Global";
    qe.forEach(function(a) {
      n[a.pluginName] && (n[a.pluginName][i] && n[a.pluginName][i](Oe({
        sortable: n
      }, o)), n.options[a.pluginName] && n[a.pluginName][e] && n[a.pluginName][e](Oe({
        sortable: n
      }, o)));
    });
  },
  initializePlugins: function(e, n, o, r) {
    qe.forEach(function(l) {
      var s = l.pluginName;
      if (!(!e.options[s] && !l.initializeByDefault)) {
        var c = new l(e, n, e.options);
        c.sortable = e, c.options = e.options, e[s] = c, Ie(o, c.defaults);
      }
    });
    for (var i in e.options)
      if (e.options.hasOwnProperty(i)) {
        var a = this.modifyOption(e, i, e.options[i]);
        typeof a < "u" && (e.options[i] = a);
      }
  },
  getEventProperties: function(e, n) {
    var o = {};
    return qe.forEach(function(r) {
      typeof r.eventProperties == "function" && Ie(o, r.eventProperties.call(n[r.pluginName], e));
    }), o;
  },
  modifyOption: function(e, n, o) {
    var r;
    return qe.forEach(function(i) {
      e[i.pluginName] && i.optionListeners && typeof i.optionListeners[n] == "function" && (r = i.optionListeners[n].call(e[i.pluginName], o));
    }), r;
  }
};
function xr(t) {
  var e = t.sortable, n = t.rootEl, o = t.name, r = t.targetEl, i = t.cloneEl, a = t.toEl, l = t.fromEl, s = t.oldIndex, c = t.newIndex, d = t.oldDraggableIndex, u = t.newDraggableIndex, y = t.originalEvent, b = t.putSortable, p = t.extraEventProperties;
  if (e = e || n && n[pe], !!e) {
    var h, m = e.options, T = "on" + o.charAt(0).toUpperCase() + o.substr(1);
    window.CustomEvent && !Le && !wt ? h = new CustomEvent(o, {
      bubbles: !0,
      cancelable: !0
    }) : (h = document.createEvent("Event"), h.initEvent(o, !0, !0)), h.to = a || n, h.from = l || n, h.item = r || n, h.clone = i, h.oldIndex = s, h.newIndex = c, h.oldDraggableIndex = d, h.newDraggableIndex = u, h.originalEvent = y, h.pullMode = b ? b.lastPutMode : void 0;
    var E = Oe(Oe({}, p), _t.getEventProperties(o, e));
    for (var w in E)
      h[w] = E[w];
    n && n.dispatchEvent(h), m[T] && m[T].call(e, h);
  }
}
var Tr = ["evt"], se = function(e, n) {
  var o = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, r = o.evt, i = vr(o, Tr);
  _t.pluginEvent.bind(I)(e, n, Oe({
    dragEl: _,
    parentEl: Y,
    ghostEl: F,
    rootEl: R,
    nextEl: We,
    lastDownEl: Mt,
    cloneEl: j,
    cloneHidden: Be,
    dragStarted: rt,
    putSortable: Z,
    activeSortable: I.active,
    originalEvent: r,
    oldIndex: Ke,
    oldDraggableIndex: ct,
    newIndex: de,
    newDraggableIndex: Pe,
    hideGhostForTarget: Ao,
    unhideGhostForTarget: ko,
    cloneNowHidden: function() {
      Be = !0;
    },
    cloneNowShown: function() {
      Be = !1;
    },
    dispatchSortableEvent: function(l) {
      ae({
        sortable: n,
        name: l,
        originalEvent: r
      });
    }
  }, i));
};
function ae(t) {
  xr(Oe({
    putSortable: Z,
    cloneEl: j,
    targetEl: _,
    rootEl: R,
    oldIndex: Ke,
    oldDraggableIndex: ct,
    newIndex: de,
    newDraggableIndex: Pe
  }, t));
}
var _, Y, F, R, We, Mt, j, Be, Ke, de, ct, Pe, St, Z, Je = !1, Vt = !1, Ht = [], Ve, ye, nn, on, no, oo, rt, Ge, dt, ft = !1, Ot = !1, Pt, te, rn = [], gn = !1, Wt = [], qt = typeof document < "u", At = wo, ro = wt || Le ? "cssFloat" : "float", Er = qt && !mr && !wo && "draggable" in document.createElement("div"), Eo = function() {
  if (qt) {
    if (Le)
      return !1;
    var t = document.createElement("x");
    return t.style.cssText = "pointer-events:auto", t.style.pointerEvents === "auto";
  }
}(), So = function(e, n) {
  var o = $(e), r = parseInt(o.width) - parseInt(o.paddingLeft) - parseInt(o.paddingRight) - parseInt(o.borderLeftWidth) - parseInt(o.borderRightWidth), i = Ze(e, 0, n), a = Ze(e, 1, n), l = i && $(i), s = a && $(a), c = l && parseInt(l.marginLeft) + parseInt(l.marginRight) + G(i).width, d = s && parseInt(s.marginLeft) + parseInt(s.marginRight) + G(a).width;
  if (o.display === "flex")
    return o.flexDirection === "column" || o.flexDirection === "column-reverse" ? "vertical" : "horizontal";
  if (o.display === "grid")
    return o.gridTemplateColumns.split(" ").length <= 1 ? "vertical" : "horizontal";
  if (i && l.float && l.float !== "none") {
    var u = l.float === "left" ? "left" : "right";
    return a && (s.clear === "both" || s.clear === u) ? "vertical" : "horizontal";
  }
  return i && (l.display === "block" || l.display === "flex" || l.display === "table" || l.display === "grid" || c >= r && o[ro] === "none" || a && o[ro] === "none" && c + d > r) ? "vertical" : "horizontal";
}, Sr = function(e, n, o) {
  var r = o ? e.left : e.top, i = o ? e.right : e.bottom, a = o ? e.width : e.height, l = o ? n.left : n.top, s = o ? n.right : n.bottom, c = o ? n.width : n.height;
  return r === l || i === s || r + a / 2 === l + c / 2;
}, Or = function(e, n) {
  var o;
  return Ht.some(function(r) {
    var i = r[pe].options.emptyInsertThreshold;
    if (!(!i || On(r))) {
      var a = G(r), l = e >= a.left - i && e <= a.right + i, s = n >= a.top - i && n <= a.bottom + i;
      if (l && s)
        return o = r;
    }
  }), o;
}, Oo = function(e) {
  function n(i, a) {
    return function(l, s, c, d) {
      var u = l.options.group.name && s.options.group.name && l.options.group.name === s.options.group.name;
      if (i == null && (a || u))
        return !0;
      if (i == null || i === !1)
        return !1;
      if (a && i === "clone")
        return i;
      if (typeof i == "function")
        return n(i(l, s, c, d), a)(l, s, c, d);
      var y = (a ? l : s).options.group.name;
      return i === !0 || typeof i == "string" && i === y || i.join && i.indexOf(y) > -1;
    };
  }
  var o = {}, r = e.group;
  (!r || Lt(r) != "object") && (r = {
    name: r
  }), o.name = r.name, o.checkPull = n(r.pull, !0), o.checkPut = n(r.put), o.revertClone = r.revertClone, e.group = o;
}, Ao = function() {
  !Eo && F && $(F, "display", "none");
}, ko = function() {
  !Eo && F && $(F, "display", "");
};
qt && document.addEventListener("click", function(t) {
  if (Vt)
    return t.preventDefault(), t.stopPropagation && t.stopPropagation(), t.stopImmediatePropagation && t.stopImmediatePropagation(), Vt = !1, !1;
}, !0);
var He = function(e) {
  if (_) {
    e = e.touches ? e.touches[0] : e;
    var n = Or(e.clientX, e.clientY);
    if (n) {
      var o = {};
      for (var r in e)
        e.hasOwnProperty(r) && (o[r] = e[r]);
      o.target = o.rootEl = n, o.preventDefault = void 0, o.stopPropagation = void 0, n[pe]._onDragOver(o);
    }
  }
}, Ar = function(e) {
  _ && _.parentNode[pe]._isOutsideThisEl(e.target);
};
function I(t, e) {
  if (!(t && t.nodeType && t.nodeType === 1))
    throw "Sortable: `el` must be an HTMLElement, not ".concat({}.toString.call(t));
  this.el = t, this.options = e = Ie({}, e), t[pe] = this;
  var n = {
    group: null,
    sort: !0,
    disabled: !1,
    store: null,
    handle: null,
    draggable: /^[uo]l$/i.test(t.nodeName) ? ">li" : ">*",
    swapThreshold: 1,
    // percentage; 0 <= x <= 1
    invertSwap: !1,
    // invert always
    invertedSwapThreshold: null,
    // will be set to same as swapThreshold if default
    removeCloneOnHide: !0,
    direction: function() {
      return So(t, this.options);
    },
    ghostClass: "sortable-ghost",
    chosenClass: "sortable-chosen",
    dragClass: "sortable-drag",
    ignore: "a, img",
    filter: null,
    preventOnFilter: !0,
    animation: 0,
    easing: null,
    setData: function(a, l) {
      a.setData("Text", l.textContent);
    },
    dropBubble: !1,
    dragoverBubble: !1,
    dataIdAttr: "data-id",
    delay: 0,
    delayOnTouchOnly: !1,
    touchStartThreshold: (Number.parseInt ? Number : window).parseInt(window.devicePixelRatio, 10) || 1,
    forceFallback: !1,
    fallbackClass: "sortable-fallback",
    fallbackOnBody: !1,
    fallbackTolerance: 0,
    fallbackOffset: {
      x: 0,
      y: 0
    },
    supportPointer: I.supportPointer !== !1 && "PointerEvent" in window && !st,
    emptyInsertThreshold: 5
  };
  _t.initializePlugins(this, t, n);
  for (var o in n)
    !(o in e) && (e[o] = n[o]);
  Oo(e);
  for (var r in this)
    r.charAt(0) === "_" && typeof this[r] == "function" && (this[r] = this[r].bind(this));
  this.nativeDraggable = e.forceFallback ? !1 : Er, this.nativeDraggable && (this.options.touchStartThreshold = 1), e.supportPointer ? N(t, "pointerdown", this._onTapStart) : (N(t, "mousedown", this._onTapStart), N(t, "touchstart", this._onTapStart)), this.nativeDraggable && (N(t, "dragover", this), N(t, "dragenter", this)), Ht.push(this.el), e.store && e.store.get && this.sort(e.store.get(this) || []), Ie(this, _r());
}
I.prototype = /** @lends Sortable.prototype */
{
  constructor: I,
  _isOutsideThisEl: function(e) {
    !this.el.contains(e) && e !== this.el && (Ge = null);
  },
  _getDirection: function(e, n) {
    return typeof this.options.direction == "function" ? this.options.direction.call(this, e, n, _) : this.options.direction;
  },
  _onTapStart: function(e) {
    if (e.cancelable) {
      var n = this, o = this.el, r = this.options, i = r.preventOnFilter, a = e.type, l = e.touches && e.touches[0] || e.pointerType && e.pointerType === "touch" && e, s = (l || e).target, c = e.target.shadowRoot && (e.path && e.path[0] || e.composedPath && e.composedPath()[0]) || s, d = r.filter;
      if (Br(o), !_ && !(/mousedown|pointerdown/.test(a) && e.button !== 0 || r.disabled) && !c.isContentEditable && !(!this.nativeDraggable && st && s && s.tagName.toUpperCase() === "SELECT") && (s = Te(s, r.draggable, o, !1), !(s && s.animated) && Mt !== s)) {
        if (Ke = he(s), ct = he(s, r.draggable), typeof d == "function") {
          if (d.call(this, e, s, this)) {
            ae({
              sortable: n,
              rootEl: c,
              name: "filter",
              targetEl: s,
              toEl: o,
              fromEl: o
            }), se("filter", n, {
              evt: e
            }), i && e.cancelable && e.preventDefault();
            return;
          }
        } else if (d && (d = d.split(",").some(function(u) {
          if (u = Te(c, u.trim(), o, !1), u)
            return ae({
              sortable: n,
              rootEl: u,
              name: "filter",
              targetEl: s,
              fromEl: o,
              toEl: o
            }), se("filter", n, {
              evt: e
            }), !0;
        }), d)) {
          i && e.cancelable && e.preventDefault();
          return;
        }
        r.handle && !Te(c, r.handle, o, !1) || this._prepareDragStart(e, l, s);
      }
    }
  },
  _prepareDragStart: function(e, n, o) {
    var r = this, i = r.el, a = r.options, l = i.ownerDocument, s;
    if (o && !_ && o.parentNode === i) {
      var c = G(o);
      if (R = i, _ = o, Y = _.parentNode, We = _.nextSibling, Mt = o, St = a.group, I.dragged = _, Ve = {
        target: _,
        clientX: (n || e).clientX,
        clientY: (n || e).clientY
      }, no = Ve.clientX - c.left, oo = Ve.clientY - c.top, this._lastX = (n || e).clientX, this._lastY = (n || e).clientY, _.style["will-change"] = "all", s = function() {
        if (se("delayEnded", r, {
          evt: e
        }), I.eventCanceled) {
          r._onDrop();
          return;
        }
        r._disableDelayedDragEvents(), !Qn && r.nativeDraggable && (_.draggable = !0), r._triggerDragStart(e, n), ae({
          sortable: r,
          name: "choose",
          originalEvent: e
        }), ce(_, a.chosenClass, !0);
      }, a.ignore.split(",").forEach(function(d) {
        Co(_, d.trim(), an);
      }), N(l, "dragover", He), N(l, "mousemove", He), N(l, "touchmove", He), N(l, "mouseup", r._onDrop), N(l, "touchend", r._onDrop), N(l, "touchcancel", r._onDrop), Qn && this.nativeDraggable && (this.options.touchStartThreshold = 4, _.draggable = !0), se("delayStart", this, {
        evt: e
      }), a.delay && (!a.delayOnTouchOnly || n) && (!this.nativeDraggable || !(wt || Le))) {
        if (I.eventCanceled) {
          this._onDrop();
          return;
        }
        N(l, "mouseup", r._disableDelayedDrag), N(l, "touchend", r._disableDelayedDrag), N(l, "touchcancel", r._disableDelayedDrag), N(l, "mousemove", r._delayedDragTouchMoveHandler), N(l, "touchmove", r._delayedDragTouchMoveHandler), a.supportPointer && N(l, "pointermove", r._delayedDragTouchMoveHandler), r._dragStartTimer = setTimeout(s, a.delay);
      } else
        s();
    }
  },
  _delayedDragTouchMoveHandler: function(e) {
    var n = e.touches ? e.touches[0] : e;
    Math.max(Math.abs(n.clientX - this._lastX), Math.abs(n.clientY - this._lastY)) >= Math.floor(this.options.touchStartThreshold / (this.nativeDraggable && window.devicePixelRatio || 1)) && this._disableDelayedDrag();
  },
  _disableDelayedDrag: function() {
    _ && an(_), clearTimeout(this._dragStartTimer), this._disableDelayedDragEvents();
  },
  _disableDelayedDragEvents: function() {
    var e = this.el.ownerDocument;
    B(e, "mouseup", this._disableDelayedDrag), B(e, "touchend", this._disableDelayedDrag), B(e, "touchcancel", this._disableDelayedDrag), B(e, "mousemove", this._delayedDragTouchMoveHandler), B(e, "touchmove", this._delayedDragTouchMoveHandler), B(e, "pointermove", this._delayedDragTouchMoveHandler);
  },
  _triggerDragStart: function(e, n) {
    n = n || e.pointerType == "touch" && e, !this.nativeDraggable || n ? this.options.supportPointer ? N(document, "pointermove", this._onTouchMove) : n ? N(document, "touchmove", this._onTouchMove) : N(document, "mousemove", this._onTouchMove) : (N(_, "dragend", this), N(R, "dragstart", this._onDragStart));
    try {
      document.selection ? Bt(function() {
        document.selection.empty();
      }) : window.getSelection().removeAllRanges();
    } catch {
    }
  },
  _dragStarted: function(e, n) {
    if (Je = !1, R && _) {
      se("dragStarted", this, {
        evt: n
      }), this.nativeDraggable && N(document, "dragover", Ar);
      var o = this.options;
      !e && ce(_, o.dragClass, !1), ce(_, o.ghostClass, !0), I.active = this, e && this._appendGhost(), ae({
        sortable: this,
        name: "start",
        originalEvent: n
      });
    } else
      this._nulling();
  },
  _emulateDragOver: function() {
    if (ye) {
      this._lastX = ye.clientX, this._lastY = ye.clientY, Ao();
      for (var e = document.elementFromPoint(ye.clientX, ye.clientY), n = e; e && e.shadowRoot && (e = e.shadowRoot.elementFromPoint(ye.clientX, ye.clientY), e !== n); )
        n = e;
      if (_.parentNode[pe]._isOutsideThisEl(e), n)
        do {
          if (n[pe]) {
            var o = void 0;
            if (o = n[pe]._onDragOver({
              clientX: ye.clientX,
              clientY: ye.clientY,
              target: e,
              rootEl: n
            }), o && !this.options.dragoverBubble)
              break;
          }
          e = n;
        } while (n = n.parentNode);
      ko();
    }
  },
  _onTouchMove: function(e) {
    if (Ve) {
      var n = this.options, o = n.fallbackTolerance, r = n.fallbackOffset, i = e.touches ? e.touches[0] : e, a = F && Qe(F, !0), l = F && a && a.a, s = F && a && a.d, c = At && te && to(te), d = (i.clientX - Ve.clientX + r.x) / (l || 1) + (c ? c[0] - rn[0] : 0) / (l || 1), u = (i.clientY - Ve.clientY + r.y) / (s || 1) + (c ? c[1] - rn[1] : 0) / (s || 1);
      if (!I.active && !Je) {
        if (o && Math.max(Math.abs(i.clientX - this._lastX), Math.abs(i.clientY - this._lastY)) < o)
          return;
        this._onDragStart(e, !0);
      }
      if (F) {
        a ? (a.e += d - (nn || 0), a.f += u - (on || 0)) : a = {
          a: 1,
          b: 0,
          c: 0,
          d: 1,
          e: d,
          f: u
        };
        var y = "matrix(".concat(a.a, ",").concat(a.b, ",").concat(a.c, ",").concat(a.d, ",").concat(a.e, ",").concat(a.f, ")");
        $(F, "webkitTransform", y), $(F, "mozTransform", y), $(F, "msTransform", y), $(F, "transform", y), nn = d, on = u, ye = i;
      }
      e.cancelable && e.preventDefault();
    }
  },
  _appendGhost: function() {
    if (!F) {
      var e = this.options.fallbackOnBody ? document.body : R, n = G(_, !0, At, !0, e), o = this.options;
      if (At) {
        for (te = e; $(te, "position") === "static" && $(te, "transform") === "none" && te !== document; )
          te = te.parentNode;
        te !== document.body && te !== document.documentElement ? (te === document && (te = Ee()), n.top += te.scrollTop, n.left += te.scrollLeft) : te = Ee(), rn = to(te);
      }
      F = _.cloneNode(!0), ce(F, o.ghostClass, !1), ce(F, o.fallbackClass, !0), ce(F, o.dragClass, !0), $(F, "transition", ""), $(F, "transform", ""), $(F, "box-sizing", "border-box"), $(F, "margin", 0), $(F, "top", n.top), $(F, "left", n.left), $(F, "width", n.width), $(F, "height", n.height), $(F, "opacity", "0.8"), $(F, "position", At ? "absolute" : "fixed"), $(F, "zIndex", "100000"), $(F, "pointerEvents", "none"), I.ghost = F, e.appendChild(F), $(F, "transform-origin", no / parseInt(F.style.width) * 100 + "% " + oo / parseInt(F.style.height) * 100 + "%");
    }
  },
  _onDragStart: function(e, n) {
    var o = this, r = e.dataTransfer, i = o.options;
    if (se("dragStart", this, {
      evt: e
    }), I.eventCanceled) {
      this._onDrop();
      return;
    }
    se("setupClone", this), I.eventCanceled || (j = To(_), j.draggable = !1, j.style["will-change"] = "", this._hideClone(), ce(j, this.options.chosenClass, !1), I.clone = j), o.cloneId = Bt(function() {
      se("clone", o), !I.eventCanceled && (o.options.removeCloneOnHide || R.insertBefore(j, _), o._hideClone(), ae({
        sortable: o,
        name: "clone"
      }));
    }), !n && ce(_, i.dragClass, !0), n ? (Vt = !0, o._loopId = setInterval(o._emulateDragOver, 50)) : (B(document, "mouseup", o._onDrop), B(document, "touchend", o._onDrop), B(document, "touchcancel", o._onDrop), r && (r.effectAllowed = "move", i.setData && i.setData.call(o, r, _)), N(document, "drop", o), $(_, "transform", "translateZ(0)")), Je = !0, o._dragStartId = Bt(o._dragStarted.bind(o, n, e)), N(document, "selectstart", o), rt = !0, st && $(document.body, "user-select", "none");
  },
  // Returns true - if no further action is needed (either inserted or another condition)
  _onDragOver: function(e) {
    var n = this.el, o = e.target, r, i, a, l = this.options, s = l.group, c = I.active, d = St === s, u = l.sort, y = Z || c, b, p = this, h = !1;
    if (gn)
      return;
    function m(U, J) {
      se(U, p, Oe({
        evt: e,
        isOwner: d,
        axis: b ? "vertical" : "horizontal",
        revert: a,
        dragRect: r,
        targetRect: i,
        canSort: u,
        fromSortable: y,
        target: o,
        completed: E,
        onMove: function(ve, Me) {
          return kt(R, n, _, r, ve, G(ve), e, Me);
        },
        changed: w
      }, J));
    }
    function T() {
      m("dragOverAnimationCapture"), p.captureAnimationState(), p !== y && y.captureAnimationState();
    }
    function E(U) {
      return m("dragOverCompleted", {
        insertion: U
      }), U && (d ? c._hideClone() : c._showClone(p), p !== y && (ce(_, Z ? Z.options.ghostClass : c.options.ghostClass, !1), ce(_, l.ghostClass, !0)), Z !== p && p !== I.active ? Z = p : p === I.active && Z && (Z = null), y === p && (p._ignoreWhileAnimating = o), p.animateAll(function() {
        m("dragOverAnimationComplete"), p._ignoreWhileAnimating = null;
      }), p !== y && (y.animateAll(), y._ignoreWhileAnimating = null)), (o === _ && !_.animated || o === n && !o.animated) && (Ge = null), !l.dragoverBubble && !e.rootEl && o !== document && (_.parentNode[pe]._isOutsideThisEl(e.target), !U && He(e)), !l.dragoverBubble && e.stopPropagation && e.stopPropagation(), h = !0;
    }
    function w() {
      de = he(_), Pe = he(_, l.draggable), ae({
        sortable: p,
        name: "change",
        toEl: n,
        newIndex: de,
        newDraggableIndex: Pe,
        originalEvent: e
      });
    }
    if (e.preventDefault !== void 0 && e.cancelable && e.preventDefault(), o = Te(o, l.draggable, n, !0), m("dragOver"), I.eventCanceled)
      return h;
    if (_.contains(e.target) || o.animated && o.animatingX && o.animatingY || p._ignoreWhileAnimating === o)
      return E(!1);
    if (Vt = !1, c && !l.disabled && (d ? u || (a = Y !== R) : Z === this || (this.lastPutMode = St.checkPull(this, c, _, e)) && s.checkPut(this, c, _, e))) {
      if (b = this._getDirection(e, o) === "vertical", r = G(_), m("dragOverValid"), I.eventCanceled)
        return h;
      if (a)
        return Y = R, T(), this._hideClone(), m("revert"), I.eventCanceled || (We ? R.insertBefore(_, We) : R.appendChild(_)), E(!0);
      var D = On(n, l.draggable);
      if (!D || Fr(e, b, this) && !D.animated) {
        if (D === _)
          return E(!1);
        if (D && n === e.target && (o = D), o && (i = G(o)), kt(R, n, _, r, o, i, e, !!o) !== !1)
          return T(), n.appendChild(_), Y = n, w(), E(!0);
      } else if (D && Ir(e, b, this)) {
        var S = Ze(n, 0, l, !0);
        if (S === _)
          return E(!1);
        if (o = S, i = G(o), kt(R, n, _, r, o, i, e, !1) !== !1)
          return T(), n.insertBefore(_, S), Y = n, w(), E(!0);
      } else if (o.parentNode === n) {
        i = G(o);
        var k = 0, g, C = _.parentNode !== n, v = !Sr(_.animated && _.toRect || r, o.animated && o.toRect || i, b), x = b ? "top" : "left", O = eo(o, "top", "top") || eo(_, "top", "top"), V = O ? O.scrollTop : void 0;
        Ge !== o && (g = i[x], ft = !1, Ot = !v && l.invertSwap || C), k = Lr(e, o, i, b, v ? 1 : l.swapThreshold, l.invertedSwapThreshold == null ? l.swapThreshold : l.invertedSwapThreshold, Ot, Ge === o);
        var A;
        if (k !== 0) {
          var H = he(_);
          do
            H -= k, A = Y.children[H];
          while (A && ($(A, "display") === "none" || A === F));
        }
        if (k === 0 || A === o)
          return E(!1);
        Ge = o, dt = k;
        var ie = o.nextElementSibling, W = !1;
        W = k === 1;
        var le = kt(R, n, _, r, o, i, e, W);
        if (le !== !1)
          return (le === 1 || le === -1) && (W = le === 1), gn = !0, setTimeout($r, 30), T(), W && !ie ? n.appendChild(_) : o.parentNode.insertBefore(_, W ? ie : o), O && xo(O, 0, V - O.scrollTop), Y = _.parentNode, g !== void 0 && !Ot && (Pt = Math.abs(g - G(o)[x])), w(), E(!0);
      }
      if (n.contains(_))
        return E(!1);
    }
    return !1;
  },
  _ignoreWhileAnimating: null,
  _offMoveEvents: function() {
    B(document, "mousemove", this._onTouchMove), B(document, "touchmove", this._onTouchMove), B(document, "pointermove", this._onTouchMove), B(document, "dragover", He), B(document, "mousemove", He), B(document, "touchmove", He);
  },
  _offUpEvents: function() {
    var e = this.el.ownerDocument;
    B(e, "mouseup", this._onDrop), B(e, "touchend", this._onDrop), B(e, "pointerup", this._onDrop), B(e, "touchcancel", this._onDrop), B(document, "selectstart", this);
  },
  _onDrop: function(e) {
    var n = this.el, o = this.options;
    if (de = he(_), Pe = he(_, o.draggable), se("drop", this, {
      evt: e
    }), Y = _ && _.parentNode, de = he(_), Pe = he(_, o.draggable), I.eventCanceled) {
      this._nulling();
      return;
    }
    Je = !1, Ot = !1, ft = !1, clearInterval(this._loopId), clearTimeout(this._dragStartTimer), bn(this.cloneId), bn(this._dragStartId), this.nativeDraggable && (B(document, "drop", this), B(n, "dragstart", this._onDragStart)), this._offMoveEvents(), this._offUpEvents(), st && $(document.body, "user-select", ""), $(_, "transform", ""), e && (rt && (e.cancelable && e.preventDefault(), !o.dropBubble && e.stopPropagation()), F && F.parentNode && F.parentNode.removeChild(F), (R === Y || Z && Z.lastPutMode !== "clone") && j && j.parentNode && j.parentNode.removeChild(j), _ && (this.nativeDraggable && B(_, "dragend", this), an(_), _.style["will-change"] = "", rt && !Je && ce(_, Z ? Z.options.ghostClass : this.options.ghostClass, !1), ce(_, this.options.chosenClass, !1), ae({
      sortable: this,
      name: "unchoose",
      toEl: Y,
      newIndex: null,
      newDraggableIndex: null,
      originalEvent: e
    }), R !== Y ? (de >= 0 && (ae({
      rootEl: Y,
      name: "add",
      toEl: Y,
      fromEl: R,
      originalEvent: e
    }), ae({
      sortable: this,
      name: "remove",
      toEl: Y,
      originalEvent: e
    }), ae({
      rootEl: Y,
      name: "sort",
      toEl: Y,
      fromEl: R,
      originalEvent: e
    }), ae({
      sortable: this,
      name: "sort",
      toEl: Y,
      originalEvent: e
    })), Z && Z.save()) : de !== Ke && de >= 0 && (ae({
      sortable: this,
      name: "update",
      toEl: Y,
      originalEvent: e
    }), ae({
      sortable: this,
      name: "sort",
      toEl: Y,
      originalEvent: e
    })), I.active && ((de == null || de === -1) && (de = Ke, Pe = ct), ae({
      sortable: this,
      name: "end",
      toEl: Y,
      originalEvent: e
    }), this.save()))), this._nulling();
  },
  _nulling: function() {
    se("nulling", this), R = _ = Y = F = We = j = Mt = Be = Ve = ye = rt = de = Pe = Ke = ct = Ge = dt = Z = St = I.dragged = I.ghost = I.clone = I.active = null, Wt.forEach(function(e) {
      e.checked = !0;
    }), Wt.length = nn = on = 0;
  },
  handleEvent: function(e) {
    switch (e.type) {
      case "drop":
      case "dragend":
        this._onDrop(e);
        break;
      case "dragenter":
      case "dragover":
        _ && (this._onDragOver(e), kr(e));
        break;
      case "selectstart":
        e.preventDefault();
        break;
    }
  },
  /**
   * Serializes the item into an array of string.
   * @returns {String[]}
   */
  toArray: function() {
    for (var e = [], n, o = this.el.children, r = 0, i = o.length, a = this.options; r < i; r++)
      n = o[r], Te(n, a.draggable, this.el, !1) && e.push(n.getAttribute(a.dataIdAttr) || Pr(n));
    return e;
  },
  /**
   * Sorts the elements according to the array.
   * @param  {String[]}  order  order of the items
   */
  sort: function(e, n) {
    var o = {}, r = this.el;
    this.toArray().forEach(function(i, a) {
      var l = r.children[a];
      Te(l, this.options.draggable, r, !1) && (o[i] = l);
    }, this), n && this.captureAnimationState(), e.forEach(function(i) {
      o[i] && (r.removeChild(o[i]), r.appendChild(o[i]));
    }), n && this.animateAll();
  },
  /**
   * Save the current sorting
   */
  save: function() {
    var e = this.options.store;
    e && e.set && e.set(this);
  },
  /**
   * For each element in the set, get the first element that matches the selector by testing the element itself and traversing up through its ancestors in the DOM tree.
   * @param   {HTMLElement}  el
   * @param   {String}       [selector]  default: `options.draggable`
   * @returns {HTMLElement|null}
   */
  closest: function(e, n) {
    return Te(e, n || this.options.draggable, this.el, !1);
  },
  /**
   * Set/get option
   * @param   {string} name
   * @param   {*}      [value]
   * @returns {*}
   */
  option: function(e, n) {
    var o = this.options;
    if (n === void 0)
      return o[e];
    var r = _t.modifyOption(this, e, n);
    typeof r < "u" ? o[e] = r : o[e] = n, e === "group" && Oo(o);
  },
  /**
   * Destroy
   */
  destroy: function() {
    se("destroy", this);
    var e = this.el;
    e[pe] = null, B(e, "mousedown", this._onTapStart), B(e, "touchstart", this._onTapStart), B(e, "pointerdown", this._onTapStart), this.nativeDraggable && (B(e, "dragover", this), B(e, "dragenter", this)), Array.prototype.forEach.call(e.querySelectorAll("[draggable]"), function(n) {
      n.removeAttribute("draggable");
    }), this._onDrop(), this._disableDelayedDragEvents(), Ht.splice(Ht.indexOf(this.el), 1), this.el = e = null;
  },
  _hideClone: function() {
    if (!Be) {
      if (se("hideClone", this), I.eventCanceled)
        return;
      $(j, "display", "none"), this.options.removeCloneOnHide && j.parentNode && j.parentNode.removeChild(j), Be = !0;
    }
  },
  _showClone: function(e) {
    if (e.lastPutMode !== "clone") {
      this._hideClone();
      return;
    }
    if (Be) {
      if (se("showClone", this), I.eventCanceled)
        return;
      _.parentNode == R && !this.options.group.revertClone ? R.insertBefore(j, _) : We ? R.insertBefore(j, We) : R.appendChild(j), this.options.group.revertClone && this.animate(_, j), $(j, "display", ""), Be = !1;
    }
  }
};
function kr(t) {
  t.dataTransfer && (t.dataTransfer.dropEffect = "move"), t.cancelable && t.preventDefault();
}
function kt(t, e, n, o, r, i, a, l) {
  var s, c = t[pe], d = c.options.onMove, u;
  return window.CustomEvent && !Le && !wt ? s = new CustomEvent("move", {
    bubbles: !0,
    cancelable: !0
  }) : (s = document.createEvent("Event"), s.initEvent("move", !0, !0)), s.to = e, s.from = t, s.dragged = n, s.draggedRect = o, s.related = r || e, s.relatedRect = i || G(e), s.willInsertAfter = l, s.originalEvent = a, t.dispatchEvent(s), d && (u = d.call(c, s, a)), u;
}
function an(t) {
  t.draggable = !1;
}
function $r() {
  gn = !1;
}
function Ir(t, e, n) {
  var o = G(Ze(n.el, 0, n.options, !0)), r = 10;
  return e ? t.clientX < o.left - r || t.clientY < o.top && t.clientX < o.right : t.clientY < o.top - r || t.clientY < o.bottom && t.clientX < o.left;
}
function Fr(t, e, n) {
  var o = G(On(n.el, n.options.draggable)), r = 10;
  return e ? t.clientX > o.right + r || t.clientX <= o.right && t.clientY > o.bottom && t.clientX >= o.left : t.clientX > o.right && t.clientY > o.top || t.clientX <= o.right && t.clientY > o.bottom + r;
}
function Lr(t, e, n, o, r, i, a, l) {
  var s = o ? t.clientY : t.clientX, c = o ? n.height : n.width, d = o ? n.top : n.left, u = o ? n.bottom : n.right, y = !1;
  if (!a) {
    if (l && Pt < c * r) {
      if (!ft && (dt === 1 ? s > d + c * i / 2 : s < u - c * i / 2) && (ft = !0), ft)
        y = !0;
      else if (dt === 1 ? s < d + Pt : s > u - Pt)
        return -dt;
    } else if (s > d + c * (1 - r) / 2 && s < u - c * (1 - r) / 2)
      return Mr(e);
  }
  return y = y || a, y && (s < d + c * i / 2 || s > u - c * i / 2) ? s > d + c / 2 ? 1 : -1 : 0;
}
function Mr(t) {
  return he(_) < he(t) ? 1 : -1;
}
function Pr(t) {
  for (var e = t.tagName + t.className + t.src + t.href + t.textContent, n = e.length, o = 0; n--; )
    o += e.charCodeAt(n);
  return o.toString(36);
}
function Br(t) {
  Wt.length = 0;
  for (var e = t.getElementsByTagName("input"), n = e.length; n--; ) {
    var o = e[n];
    o.checked && Wt.push(o);
  }
}
function Bt(t) {
  return setTimeout(t, 0);
}
function bn(t) {
  return clearTimeout(t);
}
qt && N(document, "touchmove", function(t) {
  (I.active || Je) && t.cancelable && t.preventDefault();
});
I.utils = {
  on: N,
  off: B,
  css: $,
  find: Co,
  is: function(e, n) {
    return !!Te(e, n, e, !1);
  },
  extend: yr,
  throttle: Do,
  closest: Te,
  toggleClass: ce,
  clone: To,
  index: he,
  nextTick: Bt,
  cancelNextTick: bn,
  detectDirection: So,
  getChild: Ze
};
I.get = function(t) {
  return t[pe];
};
I.mount = function() {
  for (var t = arguments.length, e = new Array(t), n = 0; n < t; n++)
    e[n] = arguments[n];
  e[0].constructor === Array && (e = e[0]), e.forEach(function(o) {
    if (!o.prototype || !o.prototype.constructor)
      throw "Sortable: Mounted plugin must be a constructor function, not ".concat({}.toString.call(o));
    o.utils && (I.utils = Oe(Oe({}, I.utils), o.utils)), _t.mount(o);
  });
};
I.create = function(t, e) {
  return new I(t, e);
};
I.version = hr;
var X = [], it, yn, wn = !1, ln, sn, Ut, at;
function Nr() {
  function t() {
    this.defaults = {
      scroll: !0,
      forceAutoScrollFallback: !1,
      scrollSensitivity: 30,
      scrollSpeed: 10,
      bubbleScroll: !0
    };
    for (var e in this)
      e.charAt(0) === "_" && typeof this[e] == "function" && (this[e] = this[e].bind(this));
  }
  return t.prototype = {
    dragStarted: function(n) {
      var o = n.originalEvent;
      this.sortable.nativeDraggable ? N(document, "dragover", this._handleAutoScroll) : this.options.supportPointer ? N(document, "pointermove", this._handleFallbackAutoScroll) : o.touches ? N(document, "touchmove", this._handleFallbackAutoScroll) : N(document, "mousemove", this._handleFallbackAutoScroll);
    },
    dragOverCompleted: function(n) {
      var o = n.originalEvent;
      !this.options.dragOverBubble && !o.rootEl && this._handleAutoScroll(o);
    },
    drop: function() {
      this.sortable.nativeDraggable ? B(document, "dragover", this._handleAutoScroll) : (B(document, "pointermove", this._handleFallbackAutoScroll), B(document, "touchmove", this._handleFallbackAutoScroll), B(document, "mousemove", this._handleFallbackAutoScroll)), io(), Nt(), wr();
    },
    nulling: function() {
      Ut = yn = it = wn = at = ln = sn = null, X.length = 0;
    },
    _handleFallbackAutoScroll: function(n) {
      this._handleAutoScroll(n, !0);
    },
    _handleAutoScroll: function(n, o) {
      var r = this, i = (n.touches ? n.touches[0] : n).clientX, a = (n.touches ? n.touches[0] : n).clientY, l = document.elementFromPoint(i, a);
      if (Ut = n, o || this.options.forceAutoScrollFallback || wt || Le || st) {
        un(n, this.options, l, o);
        var s = Ne(l, !0);
        wn && (!at || i !== ln || a !== sn) && (at && io(), at = setInterval(function() {
          var c = Ne(document.elementFromPoint(i, a), !0);
          c !== s && (s = c, Nt()), un(n, r.options, c, o);
        }, 10), ln = i, sn = a);
      } else {
        if (!this.options.bubbleScroll || Ne(l, !0) === Ee()) {
          Nt();
          return;
        }
        un(n, this.options, Ne(l, !1), !1);
      }
    }
  }, Ie(t, {
    pluginName: "scroll",
    initializeByDefault: !0
  });
}
function Nt() {
  X.forEach(function(t) {
    clearInterval(t.pid);
  }), X = [];
}
function io() {
  clearInterval(at);
}
var un = Do(function(t, e, n, o) {
  if (e.scroll) {
    var r = (t.touches ? t.touches[0] : t).clientX, i = (t.touches ? t.touches[0] : t).clientY, a = e.scrollSensitivity, l = e.scrollSpeed, s = Ee(), c = !1, d;
    yn !== n && (yn = n, Nt(), it = e.scroll, d = e.scrollFn, it === !0 && (it = Ne(n, !0)));
    var u = 0, y = it;
    do {
      var b = y, p = G(b), h = p.top, m = p.bottom, T = p.left, E = p.right, w = p.width, D = p.height, S = void 0, k = void 0, g = b.scrollWidth, C = b.scrollHeight, v = $(b), x = b.scrollLeft, O = b.scrollTop;
      b === s ? (S = w < g && (v.overflowX === "auto" || v.overflowX === "scroll" || v.overflowX === "visible"), k = D < C && (v.overflowY === "auto" || v.overflowY === "scroll" || v.overflowY === "visible")) : (S = w < g && (v.overflowX === "auto" || v.overflowX === "scroll"), k = D < C && (v.overflowY === "auto" || v.overflowY === "scroll"));
      var V = S && (Math.abs(E - r) <= a && x + w < g) - (Math.abs(T - r) <= a && !!x), A = k && (Math.abs(m - i) <= a && O + D < C) - (Math.abs(h - i) <= a && !!O);
      if (!X[u])
        for (var H = 0; H <= u; H++)
          X[H] || (X[H] = {});
      (X[u].vx != V || X[u].vy != A || X[u].el !== b) && (X[u].el = b, X[u].vx = V, X[u].vy = A, clearInterval(X[u].pid), (V != 0 || A != 0) && (c = !0, X[u].pid = setInterval((function() {
        o && this.layer === 0 && I.active._onTouchMove(Ut);
        var ie = X[this.layer].vy ? X[this.layer].vy * l : 0, W = X[this.layer].vx ? X[this.layer].vx * l : 0;
        typeof d == "function" && d.call(I.dragged.parentNode[pe], W, ie, t, Ut, X[this.layer].el) !== "continue" || xo(X[this.layer].el, W, ie);
      }).bind({
        layer: u
      }), 24))), u++;
    } while (e.bubbleScroll && y !== s && (y = Ne(y, !1)));
    wn = c;
  }
}, 30), $o = function(e) {
  var n = e.originalEvent, o = e.putSortable, r = e.dragEl, i = e.activeSortable, a = e.dispatchSortableEvent, l = e.hideGhostForTarget, s = e.unhideGhostForTarget;
  if (n) {
    var c = o || i;
    l();
    var d = n.changedTouches && n.changedTouches.length ? n.changedTouches[0] : n, u = document.elementFromPoint(d.clientX, d.clientY);
    s(), c && !c.el.contains(u) && (a("spill"), this.onSpill({
      dragEl: r,
      putSortable: o
    }));
  }
};
function An() {
}
An.prototype = {
  startIndex: null,
  dragStart: function(e) {
    var n = e.oldDraggableIndex;
    this.startIndex = n;
  },
  onSpill: function(e) {
    var n = e.dragEl, o = e.putSortable;
    this.sortable.captureAnimationState(), o && o.captureAnimationState();
    var r = Ze(this.sortable.el, this.startIndex, this.options);
    r ? this.sortable.el.insertBefore(n, r) : this.sortable.el.appendChild(n), this.sortable.animateAll(), o && o.animateAll();
  },
  drop: $o
};
Ie(An, {
  pluginName: "revertOnSpill"
});
function kn() {
}
kn.prototype = {
  onSpill: function(e) {
    var n = e.dragEl, o = e.putSortable, r = o || this.sortable;
    r.captureAnimationState(), n.parentNode && n.parentNode.removeChild(n), r.animateAll();
  },
  drop: $o
};
Ie(kn, {
  pluginName: "removeOnSpill"
});
I.mount(new Nr());
I.mount(kn, An);
function Rr() {
  return typeof window < "u" ? window.console : global.console;
}
const Yr = Rr();
function jr(t) {
  const e = /* @__PURE__ */ Object.create(null);
  return function(o) {
    return e[o] || (e[o] = t(o));
  };
}
const Vr = /-(\w)/g, ao = jr((t) => t.replace(Vr, (e, n) => n ? n.toUpperCase() : ""));
function cn(t) {
  t.parentElement !== null && t.parentElement.removeChild(t);
}
function lo(t, e, n) {
  const o = n === 0 ? t.children[0] : t.children[n - 1].nextSibling;
  t.insertBefore(e, o);
}
function Hr(t, e) {
  return Object.values(t).indexOf(e);
}
function Wr(t, e, n, o) {
  if (!t)
    return [];
  const r = Object.values(t), i = e.length - o;
  return [...e].map((l, s) => s >= i ? r.length : r.indexOf(l));
}
function Io(t, e) {
  this.$nextTick(() => this.$emit(t.toLowerCase(), e));
}
function Ur(t) {
  return (e) => {
    this.realList !== null && this["onDrag" + t](e), Io.call(this, t, e);
  };
}
function zr(t) {
  return ["transition-group", "TransitionGroup"].includes(t);
}
function Xr(t) {
  if (!t || t.length !== 1)
    return !1;
  const [{ type: e }] = t;
  return e ? zr(e.name) : !1;
}
function qr(t, e) {
  return e ? { ...e.props, ...e.attrs } : t;
}
const _n = ["Start", "Add", "Remove", "Update", "End"], Cn = ["Choose", "Unchoose", "Sort", "Filter", "Clone"], Gr = ["Move", ..._n, ...Cn].map((t) => "on" + t);
let dn = null;
const Jr = {
  options: Object,
  list: {
    type: Array,
    required: !1,
    default: null
  },
  noTransitionOnDrag: {
    type: Boolean,
    default: !1
  },
  clone: {
    type: Function,
    default: (t) => t
  },
  tag: {
    type: String,
    default: "div"
  },
  move: {
    type: Function,
    default: null
  },
  componentData: {
    type: Object,
    required: !1,
    default: null
  },
  component: {
    type: String,
    default: null
  },
  modelValue: {
    type: Array,
    required: !1,
    default: null
  }
}, Kr = bt({
  name: "VueDraggableNext",
  inheritAttrs: !1,
  emits: [
    "update:modelValue",
    "move",
    "change",
    ..._n.map((t) => t.toLowerCase()),
    ...Cn.map((t) => t.toLowerCase())
  ],
  props: Jr,
  data() {
    return {
      transitionMode: !1,
      noneFunctionalComponentMode: !1,
      headerOffset: 0,
      footerOffset: 0,
      _sortable: {},
      visibleIndexes: [],
      context: {}
    };
  },
  render() {
    const t = this.$slots.default ? this.$slots.default() : null, e = qr(this.$attrs, this.componentData);
    return t ? (this.transitionMode = Xr(t), Xn(this.getTag(), e, t)) : Xn(this.getTag(), e, []);
  },
  created() {
    this.list !== null && this.modelValue !== null && Yr.error("list props are mutually exclusive! Please set one.");
  },
  mounted() {
    const t = {};
    _n.forEach((r) => {
      t["on" + r] = Ur.call(this, r);
    }), Cn.forEach((r) => {
      t["on" + r] = Io.bind(this, r);
    });
    const e = Object.keys(this.$attrs).reduce((r, i) => (r[ao(i)] = this.$attrs[i], r), {}), n = Object.assign({}, e, t, {
      onMove: (r, i) => this.onDragMove(r, i)
    });
    !("draggable" in n) && (n.draggable = ">*");
    const o = this.$el.nodeType === 1 ? this.$el : this.$el.parentElement;
    this._sortable = new I(o, n), o.__draggable_component__ = this, this.computeIndexes();
  },
  beforeUnmount() {
    try {
      this._sortable !== void 0 && this._sortable.destroy();
    } catch {
    }
  },
  computed: {
    realList() {
      return this.list ? this.list : this.modelValue;
    }
  },
  watch: {
    $attrs: {
      handler(t) {
        this.updateOptions(t);
      },
      deep: !0
    },
    realList() {
      this.computeIndexes();
    }
  },
  methods: {
    getTag() {
      return this.component ? Xo(this.component) : this.tag;
    },
    updateOptions(t) {
      for (var e in t) {
        const n = ao(e);
        Gr.indexOf(n) === -1 && this._sortable.option(n, t[e]);
      }
    },
    getChildrenNodes() {
      return this.$el.children;
    },
    computeIndexes() {
      this.$nextTick(() => {
        this.visibleIndexes = Wr(this.getChildrenNodes(), this.$el.children, this.transitionMode, this.footerOffset);
      });
    },
    getUnderlyingVm(t) {
      const e = Hr(this.getChildrenNodes() || [], t);
      if (e === -1)
        return null;
      const n = this.realList[e];
      return { index: e, element: n };
    },
    emitChanges(t) {
      this.$nextTick(() => {
        this.$emit("change", t);
      });
    },
    alterList(t) {
      if (this.list) {
        t(this.list);
        return;
      }
      const e = [...this.modelValue];
      t(e), this.$emit("update:modelValue", e);
    },
    spliceList() {
      const t = (e) => e.splice(...arguments);
      this.alterList(t);
    },
    updatePosition(t, e) {
      const n = (o) => o.splice(e, 0, o.splice(t, 1)[0]);
      this.alterList(n);
    },
    getVmIndex(t) {
      const e = this.visibleIndexes, n = e.length;
      return t > n - 1 ? n : e[t];
    },
    getComponent() {
      return this.$slots.default ? (
        //@ts-ignore
        this.$slots.default()[0].componentInstance
      ) : null;
    },
    resetTransitionData(t) {
      if (!this.noTransitionOnDrag || !this.transitionMode)
        return;
      var e = this.getChildrenNodes();
      e[t].data = null;
      const n = this.getComponent();
      n.children = [], n.kept = void 0;
    },
    onDragStart(t) {
      this.computeIndexes(), this.context = this.getUnderlyingVm(t.item), this.context && (t.item._underlying_vm_ = this.clone(this.context.element), dn = t.item);
    },
    onDragAdd(t) {
      const e = t.item._underlying_vm_;
      if (e === void 0)
        return;
      cn(t.item);
      const n = this.getVmIndex(t.newIndex);
      this.spliceList(n, 0, e), this.computeIndexes();
      const o = { element: e, newIndex: n };
      this.emitChanges({ added: o });
    },
    onDragRemove(t) {
      if (lo(this.$el, t.item, t.oldIndex), t.pullMode === "clone") {
        cn(t.clone);
        return;
      }
      if (!this.context)
        return;
      const e = this.context.index;
      this.spliceList(e, 1);
      const n = { element: this.context.element, oldIndex: e };
      this.resetTransitionData(e), this.emitChanges({ removed: n });
    },
    onDragUpdate(t) {
      cn(t.item), lo(t.from, t.item, t.oldIndex);
      const e = this.context.index, n = this.getVmIndex(t.newIndex);
      this.updatePosition(e, n);
      const o = { element: this.context.element, oldIndex: e, newIndex: n };
      this.emitChanges({ moved: o });
    },
    updateProperty(t, e) {
      t.hasOwnProperty(e) && (t[e] += this.headerOffset);
    },
    onDragMove(t, e) {
      const n = this.move;
      if (!n || !this.realList)
        return !0;
      const o = this.getRelatedContextFromMoveEvent(t), r = this.context, i = this.computeFutureIndex(o, t);
      Object.assign(r, { futureIndex: i });
      const a = Object.assign({}, t, {
        relatedContext: o,
        draggedContext: r
      });
      return n(a, e);
    },
    onDragEnd() {
      this.computeIndexes(), dn = null;
    },
    getTrargetedComponent(t) {
      return t.__draggable_component__;
    },
    getRelatedContextFromMoveEvent({ to: t, related: e }) {
      const n = this.getTrargetedComponent(t);
      if (!n)
        return { component: n };
      const o = n.realList, r = { list: o, component: n };
      if (t !== e && o && n.getUnderlyingVm) {
        const i = n.getUnderlyingVm(e);
        if (i)
          return Object.assign(i, r);
      }
      return r;
    },
    computeFutureIndex(t, e) {
      const n = [...e.to.children].filter((a) => a.style.display !== "none");
      if (n.length === 0)
        return 0;
      const o = n.indexOf(e.related), r = t.component.getVmIndex(o);
      return n.indexOf(dn) !== -1 || !e.willInsertAfter ? r : r + 1;
    }
  }
});
function Dn(t, e, n) {
  var o, r, i, a, l;
  e == null && (e = 100);
  function s() {
    var d = Date.now() - a;
    d < e && d >= 0 ? o = setTimeout(s, e - d) : (o = null, n || (l = t.apply(i, r), i = r = null));
  }
  var c = function() {
    i = this, r = arguments, a = Date.now();
    var d = n && !o;
    return o || (o = setTimeout(s, e)), d && (l = t.apply(i, r), i = r = null), l;
  };
  return c.clear = function() {
    o && (clearTimeout(o), o = null);
  }, c.flush = function() {
    o && (l = t.apply(i, r), i = r = null, clearTimeout(o), o = null);
  }, c;
}
Dn.debounce = Dn;
var fn = Dn;
function Qr(t, e, n) {
  er(t) ? vt(t, (o, r) => {
    r == null || r.removeEventListener(e, n), o == null || o.addEventListener(e, n);
  }) : yt(() => {
    t.addEventListener(e, n);
  }), zt(() => {
    var o;
    (o = ee(t)) === null || o === void 0 || o.removeEventListener(e, n);
  });
}
function Zr(t, e) {
  const n = "pointerdown";
  return typeof window > "u" || !window ? void 0 : Qr(window, n, (r) => {
    const i = ee(t);
    i && (i === r.target || r.composedPath().includes(i) || e(r));
  });
}
function ei(t, e, n) {
  let o = null;
  const r = ue(!1);
  yt(() => {
    (t.content !== void 0 || n.value) && (r.value = !0), o = new MutationObserver(i), o.observe(e.value, {
      childList: !0,
      subtree: !0
    });
  }), zt(() => o.disconnect()), vt(n, (a) => {
    a ? r.value = !0 : r.value = !1;
  });
  const i = () => {
    t.content ? r.value = !0 : r.value = !1;
  };
  return {
    hasContent: r
  };
}
function et(t, e) {
  var n = t.getBoundingClientRect(), o = 1, r = 1;
  return {
    width: n.width / o,
    height: n.height / r,
    top: n.top / r,
    right: n.right / o,
    bottom: n.bottom / r,
    left: n.left / o,
    x: n.left / o,
    y: n.top / r
  };
}
function De(t) {
  if (t == null)
    return window;
  if (t.toString() !== "[object Window]") {
    var e = t.ownerDocument;
    return e && e.defaultView || window;
  }
  return t;
}
function $n(t) {
  var e = De(t), n = e.pageXOffset, o = e.pageYOffset;
  return {
    scrollLeft: n,
    scrollTop: o
  };
}
function ht(t) {
  var e = De(t).Element;
  return t instanceof e || t instanceof Element;
}
function me(t) {
  var e = De(t).HTMLElement;
  return t instanceof e || t instanceof HTMLElement;
}
function Fo(t) {
  if (typeof ShadowRoot > "u")
    return !1;
  var e = De(t).ShadowRoot;
  return t instanceof e || t instanceof ShadowRoot;
}
function ti(t) {
  return {
    scrollLeft: t.scrollLeft,
    scrollTop: t.scrollTop
  };
}
function ni(t) {
  return t === De(t) || !me(t) ? $n(t) : ti(t);
}
function Ae(t) {
  return t ? (t.nodeName || "").toLowerCase() : null;
}
function Ye(t) {
  return ((ht(t) ? t.ownerDocument : (
    // $FlowFixMe[prop-missing]
    t.document
  )) || window.document).documentElement;
}
function In(t) {
  return et(Ye(t)).left + $n(t).scrollLeft;
}
function Fe(t) {
  return De(t).getComputedStyle(t);
}
function Fn(t) {
  var e = Fe(t), n = e.overflow, o = e.overflowX, r = e.overflowY;
  return /auto|scroll|overlay|hidden/.test(n + r + o);
}
function oi(t) {
  var e = t.getBoundingClientRect(), n = e.width / t.offsetWidth || 1, o = e.height / t.offsetHeight || 1;
  return n !== 1 || o !== 1;
}
function ri(t, e, n) {
  n === void 0 && (n = !1);
  var o = me(e);
  me(e) && oi(e);
  var r = Ye(e), i = et(t), a = {
    scrollLeft: 0,
    scrollTop: 0
  }, l = {
    x: 0,
    y: 0
  };
  return (o || !o && !n) && ((Ae(e) !== "body" || // https://github.com/popperjs/popper-core/issues/1078
  Fn(r)) && (a = ni(e)), me(e) ? (l = et(e), l.x += e.clientLeft, l.y += e.clientTop) : r && (l.x = In(r))), {
    x: i.left + a.scrollLeft - l.x,
    y: i.top + a.scrollTop - l.y,
    width: i.width,
    height: i.height
  };
}
function Ln(t) {
  var e = et(t), n = t.offsetWidth, o = t.offsetHeight;
  return Math.abs(e.width - n) <= 1 && (n = e.width), Math.abs(e.height - o) <= 1 && (o = e.height), {
    x: t.offsetLeft,
    y: t.offsetTop,
    width: n,
    height: o
  };
}
function Gt(t) {
  return Ae(t) === "html" ? t : (
    // this is a quicker (but less type safe) way to save quite some bytes from the bundle
    // $FlowFixMe[incompatible-return]
    // $FlowFixMe[prop-missing]
    t.assignedSlot || // step into the shadow DOM of the parent of a slotted node
    t.parentNode || // DOM Element detected
    (Fo(t) ? t.host : null) || // ShadowRoot detected
    // $FlowFixMe[incompatible-call]: HTMLElement is a Node
    Ye(t)
  );
}
function Lo(t) {
  return ["html", "body", "#document"].indexOf(Ae(t)) >= 0 ? t.ownerDocument.body : me(t) && Fn(t) ? t : Lo(Gt(t));
}
function pt(t, e) {
  var n;
  e === void 0 && (e = []);
  var o = Lo(t), r = o === ((n = t.ownerDocument) == null ? void 0 : n.body), i = De(o), a = r ? [i].concat(i.visualViewport || [], Fn(o) ? o : []) : o, l = e.concat(a);
  return r ? l : (
    // $FlowFixMe[incompatible-call]: isBody tells us target will be an HTMLElement here
    l.concat(pt(Gt(a)))
  );
}
function ii(t) {
  return ["table", "td", "th"].indexOf(Ae(t)) >= 0;
}
function so(t) {
  return !me(t) || // https://github.com/popperjs/popper-core/issues/837
  Fe(t).position === "fixed" ? null : t.offsetParent;
}
function ai(t) {
  var e = navigator.userAgent.toLowerCase().indexOf("firefox") !== -1, n = navigator.userAgent.indexOf("Trident") !== -1;
  if (n && me(t)) {
    var o = Fe(t);
    if (o.position === "fixed")
      return null;
  }
  for (var r = Gt(t); me(r) && ["html", "body"].indexOf(Ae(r)) < 0; ) {
    var i = Fe(r);
    if (i.transform !== "none" || i.perspective !== "none" || i.contain === "paint" || ["transform", "perspective"].indexOf(i.willChange) !== -1 || e && i.willChange === "filter" || e && i.filter && i.filter !== "none")
      return r;
    r = r.parentNode;
  }
  return null;
}
function Ct(t) {
  for (var e = De(t), n = so(t); n && ii(n) && Fe(n).position === "static"; )
    n = so(n);
  return n && (Ae(n) === "html" || Ae(n) === "body" && Fe(n).position === "static") ? e : n || ai(t) || e;
}
var ge = "top", _e = "bottom", Ce = "right", be = "left", Mn = "auto", Dt = [ge, _e, Ce, be], tt = "start", mt = "end", li = "clippingParents", Mo = "viewport", ot = "popper", si = "reference", uo = /* @__PURE__ */ Dt.reduce(function(t, e) {
  return t.concat([e + "-" + tt, e + "-" + mt]);
}, []), Po = /* @__PURE__ */ [].concat(Dt, [Mn]).reduce(function(t, e) {
  return t.concat([e, e + "-" + tt, e + "-" + mt]);
}, []), ui = "beforeRead", ci = "read", di = "afterRead", fi = "beforeMain", pi = "main", vi = "afterMain", hi = "beforeWrite", mi = "write", gi = "afterWrite", bi = [ui, ci, di, fi, pi, vi, hi, mi, gi];
function yi(t) {
  var e = /* @__PURE__ */ new Map(), n = /* @__PURE__ */ new Set(), o = [];
  t.forEach(function(i) {
    e.set(i.name, i);
  });
  function r(i) {
    n.add(i.name);
    var a = [].concat(i.requires || [], i.requiresIfExists || []);
    a.forEach(function(l) {
      if (!n.has(l)) {
        var s = e.get(l);
        s && r(s);
      }
    }), o.push(i);
  }
  return t.forEach(function(i) {
    n.has(i.name) || r(i);
  }), o;
}
function wi(t) {
  var e = yi(t);
  return bi.reduce(function(n, o) {
    return n.concat(e.filter(function(r) {
      return r.phase === o;
    }));
  }, []);
}
function _i(t) {
  var e;
  return function() {
    return e || (e = new Promise(function(n) {
      Promise.resolve().then(function() {
        e = void 0, n(t());
      });
    })), e;
  };
}
function Se(t) {
  return t.split("-")[0];
}
function Ci(t) {
  var e = t.reduce(function(n, o) {
    var r = n[o.name];
    return n[o.name] = r ? Object.assign({}, r, o, {
      options: Object.assign({}, r.options, o.options),
      data: Object.assign({}, r.data, o.data)
    }) : o, n;
  }, {});
  return Object.keys(e).map(function(n) {
    return e[n];
  });
}
function Di(t) {
  var e = De(t), n = Ye(t), o = e.visualViewport, r = n.clientWidth, i = n.clientHeight, a = 0, l = 0;
  return o && (r = o.width, i = o.height, /^((?!chrome|android).)*safari/i.test(navigator.userAgent) || (a = o.offsetLeft, l = o.offsetTop)), {
    width: r,
    height: i,
    x: a + In(t),
    y: l
  };
}
var Re = Math.max, gt = Math.min, $t = Math.round;
function xi(t) {
  var e, n = Ye(t), o = $n(t), r = (e = t.ownerDocument) == null ? void 0 : e.body, i = Re(n.scrollWidth, n.clientWidth, r ? r.scrollWidth : 0, r ? r.clientWidth : 0), a = Re(n.scrollHeight, n.clientHeight, r ? r.scrollHeight : 0, r ? r.clientHeight : 0), l = -o.scrollLeft + In(t), s = -o.scrollTop;
  return Fe(r || n).direction === "rtl" && (l += Re(n.clientWidth, r ? r.clientWidth : 0) - i), {
    width: i,
    height: a,
    x: l,
    y: s
  };
}
function Bo(t, e) {
  var n = e.getRootNode && e.getRootNode();
  if (t.contains(e))
    return !0;
  if (n && Fo(n)) {
    var o = e;
    do {
      if (o && t.isSameNode(o))
        return !0;
      o = o.parentNode || o.host;
    } while (o);
  }
  return !1;
}
function xn(t) {
  return Object.assign({}, t, {
    left: t.x,
    top: t.y,
    right: t.x + t.width,
    bottom: t.y + t.height
  });
}
function Ti(t) {
  var e = et(t);
  return e.top = e.top + t.clientTop, e.left = e.left + t.clientLeft, e.bottom = e.top + t.clientHeight, e.right = e.left + t.clientWidth, e.width = t.clientWidth, e.height = t.clientHeight, e.x = e.left, e.y = e.top, e;
}
function co(t, e) {
  return e === Mo ? xn(Di(t)) : me(e) ? Ti(e) : xn(xi(Ye(t)));
}
function Ei(t) {
  var e = pt(Gt(t)), n = ["absolute", "fixed"].indexOf(Fe(t).position) >= 0, o = n && me(t) ? Ct(t) : t;
  return ht(o) ? e.filter(function(r) {
    return ht(r) && Bo(r, o) && Ae(r) !== "body";
  }) : [];
}
function Si(t, e, n) {
  var o = e === "clippingParents" ? Ei(t) : [].concat(e), r = [].concat(o, [n]), i = r[0], a = r.reduce(function(l, s) {
    var c = co(t, s);
    return l.top = Re(c.top, l.top), l.right = gt(c.right, l.right), l.bottom = gt(c.bottom, l.bottom), l.left = Re(c.left, l.left), l;
  }, co(t, i));
  return a.width = a.right - a.left, a.height = a.bottom - a.top, a.x = a.left, a.y = a.top, a;
}
function nt(t) {
  return t.split("-")[1];
}
function Pn(t) {
  return ["top", "bottom"].indexOf(t) >= 0 ? "x" : "y";
}
function No(t) {
  var e = t.reference, n = t.element, o = t.placement, r = o ? Se(o) : null, i = o ? nt(o) : null, a = e.x + e.width / 2 - n.width / 2, l = e.y + e.height / 2 - n.height / 2, s;
  switch (r) {
    case ge:
      s = {
        x: a,
        y: e.y - n.height
      };
      break;
    case _e:
      s = {
        x: a,
        y: e.y + e.height
      };
      break;
    case Ce:
      s = {
        x: e.x + e.width,
        y: l
      };
      break;
    case be:
      s = {
        x: e.x - n.width,
        y: l
      };
      break;
    default:
      s = {
        x: e.x,
        y: e.y
      };
  }
  var c = r ? Pn(r) : null;
  if (c != null) {
    var d = c === "y" ? "height" : "width";
    switch (i) {
      case tt:
        s[c] = s[c] - (e[d] / 2 - n[d] / 2);
        break;
      case mt:
        s[c] = s[c] + (e[d] / 2 - n[d] / 2);
        break;
    }
  }
  return s;
}
function Ro() {
  return {
    top: 0,
    right: 0,
    bottom: 0,
    left: 0
  };
}
function Yo(t) {
  return Object.assign({}, Ro(), t);
}
function jo(t, e) {
  return e.reduce(function(n, o) {
    return n[o] = t, n;
  }, {});
}
function Bn(t, e) {
  e === void 0 && (e = {});
  var n = e, o = n.placement, r = o === void 0 ? t.placement : o, i = n.boundary, a = i === void 0 ? li : i, l = n.rootBoundary, s = l === void 0 ? Mo : l, c = n.elementContext, d = c === void 0 ? ot : c, u = n.altBoundary, y = u === void 0 ? !1 : u, b = n.padding, p = b === void 0 ? 0 : b, h = Yo(typeof p != "number" ? p : jo(p, Dt)), m = d === ot ? si : ot, T = t.rects.popper, E = t.elements[y ? m : d], w = Si(ht(E) ? E : E.contextElement || Ye(t.elements.popper), a, s), D = et(t.elements.reference), S = No({
    reference: D,
    element: T,
    strategy: "absolute",
    placement: r
  }), k = xn(Object.assign({}, T, S)), g = d === ot ? k : D, C = {
    top: w.top - g.top + h.top,
    bottom: g.bottom - w.bottom + h.bottom,
    left: w.left - g.left + h.left,
    right: g.right - w.right + h.right
  }, v = t.modifiersData.offset;
  if (d === ot && v) {
    var x = v[r];
    Object.keys(C).forEach(function(O) {
      var V = [Ce, _e].indexOf(O) >= 0 ? 1 : -1, A = [ge, _e].indexOf(O) >= 0 ? "y" : "x";
      C[O] += x[A] * V;
    });
  }
  return C;
}
var fo = {
  placement: "bottom",
  modifiers: [],
  strategy: "absolute"
};
function po() {
  for (var t = arguments.length, e = new Array(t), n = 0; n < t; n++)
    e[n] = arguments[n];
  return !e.some(function(o) {
    return !(o && typeof o.getBoundingClientRect == "function");
  });
}
function Oi(t) {
  t === void 0 && (t = {});
  var e = t, n = e.defaultModifiers, o = n === void 0 ? [] : n, r = e.defaultOptions, i = r === void 0 ? fo : r;
  return function(l, s, c) {
    c === void 0 && (c = i);
    var d = {
      placement: "bottom",
      orderedModifiers: [],
      options: Object.assign({}, fo, i),
      modifiersData: {},
      elements: {
        reference: l,
        popper: s
      },
      attributes: {},
      styles: {}
    }, u = [], y = !1, b = {
      state: d,
      setOptions: function(T) {
        var E = typeof T == "function" ? T(d.options) : T;
        h(), d.options = Object.assign({}, i, d.options, E), d.scrollParents = {
          reference: ht(l) ? pt(l) : l.contextElement ? pt(l.contextElement) : [],
          popper: pt(s)
        };
        var w = wi(Ci([].concat(o, d.options.modifiers)));
        return d.orderedModifiers = w.filter(function(D) {
          return D.enabled;
        }), p(), b.update();
      },
      // Sync update – it will always be executed, even if not necessary. This
      // is useful for low frequency updates where sync behavior simplifies the
      // logic.
      // For high frequency updates (e.g. `resize` and `scroll` events), always
      // prefer the async Popper#update method
      forceUpdate: function() {
        if (!y) {
          var T = d.elements, E = T.reference, w = T.popper;
          if (po(E, w)) {
            d.rects = {
              reference: ri(E, Ct(w), d.options.strategy === "fixed"),
              popper: Ln(w)
            }, d.reset = !1, d.placement = d.options.placement, d.orderedModifiers.forEach(function(x) {
              return d.modifiersData[x.name] = Object.assign({}, x.data);
            });
            for (var D = 0; D < d.orderedModifiers.length; D++) {
              if (d.reset === !0) {
                d.reset = !1, D = -1;
                continue;
              }
              var S = d.orderedModifiers[D], k = S.fn, g = S.options, C = g === void 0 ? {} : g, v = S.name;
              typeof k == "function" && (d = k({
                state: d,
                options: C,
                name: v,
                instance: b
              }) || d);
            }
          }
        }
      },
      // Async and optimistically optimized update – it will not be executed if
      // not necessary (debounced to run at most once-per-tick)
      update: _i(function() {
        return new Promise(function(m) {
          b.forceUpdate(), m(d);
        });
      }),
      destroy: function() {
        h(), y = !0;
      }
    };
    if (!po(l, s))
      return b;
    b.setOptions(c).then(function(m) {
      !y && c.onFirstUpdate && c.onFirstUpdate(m);
    });
    function p() {
      d.orderedModifiers.forEach(function(m) {
        var T = m.name, E = m.options, w = E === void 0 ? {} : E, D = m.effect;
        if (typeof D == "function") {
          var S = D({
            state: d,
            name: T,
            instance: b,
            options: w
          }), k = function() {
          };
          u.push(S || k);
        }
      });
    }
    function h() {
      u.forEach(function(m) {
        return m();
      }), u = [];
    }
    return b;
  };
}
var It = {
  passive: !0
};
function Ai(t) {
  var e = t.state, n = t.instance, o = t.options, r = o.scroll, i = r === void 0 ? !0 : r, a = o.resize, l = a === void 0 ? !0 : a, s = De(e.elements.popper), c = [].concat(e.scrollParents.reference, e.scrollParents.popper);
  return i && c.forEach(function(d) {
    d.addEventListener("scroll", n.update, It);
  }), l && s.addEventListener("resize", n.update, It), function() {
    i && c.forEach(function(d) {
      d.removeEventListener("scroll", n.update, It);
    }), l && s.removeEventListener("resize", n.update, It);
  };
}
var ki = {
  name: "eventListeners",
  enabled: !0,
  phase: "write",
  fn: function() {
  },
  effect: Ai,
  data: {}
};
function $i(t) {
  var e = t.state, n = t.name;
  e.modifiersData[n] = No({
    reference: e.rects.reference,
    element: e.rects.popper,
    strategy: "absolute",
    placement: e.placement
  });
}
var Ii = {
  name: "popperOffsets",
  enabled: !0,
  phase: "read",
  fn: $i,
  data: {}
}, Fi = {
  top: "auto",
  right: "auto",
  bottom: "auto",
  left: "auto"
};
function Li(t) {
  var e = t.x, n = t.y, o = window, r = o.devicePixelRatio || 1;
  return {
    x: $t($t(e * r) / r) || 0,
    y: $t($t(n * r) / r) || 0
  };
}
function vo(t) {
  var e, n = t.popper, o = t.popperRect, r = t.placement, i = t.variation, a = t.offsets, l = t.position, s = t.gpuAcceleration, c = t.adaptive, d = t.roundOffsets, u = d === !0 ? Li(a) : typeof d == "function" ? d(a) : a, y = u.x, b = y === void 0 ? 0 : y, p = u.y, h = p === void 0 ? 0 : p, m = a.hasOwnProperty("x"), T = a.hasOwnProperty("y"), E = be, w = ge, D = window;
  if (c) {
    var S = Ct(n), k = "clientHeight", g = "clientWidth";
    S === De(n) && (S = Ye(n), Fe(S).position !== "static" && l === "absolute" && (k = "scrollHeight", g = "scrollWidth")), S = S, (r === ge || (r === be || r === Ce) && i === mt) && (w = _e, h -= S[k] - o.height, h *= s ? 1 : -1), (r === be || (r === ge || r === _e) && i === mt) && (E = Ce, b -= S[g] - o.width, b *= s ? 1 : -1);
  }
  var C = Object.assign({
    position: l
  }, c && Fi);
  if (s) {
    var v;
    return Object.assign({}, C, (v = {}, v[w] = T ? "0" : "", v[E] = m ? "0" : "", v.transform = (D.devicePixelRatio || 1) <= 1 ? "translate(" + b + "px, " + h + "px)" : "translate3d(" + b + "px, " + h + "px, 0)", v));
  }
  return Object.assign({}, C, (e = {}, e[w] = T ? h + "px" : "", e[E] = m ? b + "px" : "", e.transform = "", e));
}
function Mi(t) {
  var e = t.state, n = t.options, o = n.gpuAcceleration, r = o === void 0 ? !0 : o, i = n.adaptive, a = i === void 0 ? !0 : i, l = n.roundOffsets, s = l === void 0 ? !0 : l, c = {
    placement: Se(e.placement),
    variation: nt(e.placement),
    popper: e.elements.popper,
    popperRect: e.rects.popper,
    gpuAcceleration: r
  };
  e.modifiersData.popperOffsets != null && (e.styles.popper = Object.assign({}, e.styles.popper, vo(Object.assign({}, c, {
    offsets: e.modifiersData.popperOffsets,
    position: e.options.strategy,
    adaptive: a,
    roundOffsets: s
  })))), e.modifiersData.arrow != null && (e.styles.arrow = Object.assign({}, e.styles.arrow, vo(Object.assign({}, c, {
    offsets: e.modifiersData.arrow,
    position: "absolute",
    adaptive: !1,
    roundOffsets: s
  })))), e.attributes.popper = Object.assign({}, e.attributes.popper, {
    "data-popper-placement": e.placement
  });
}
var Pi = {
  name: "computeStyles",
  enabled: !0,
  phase: "beforeWrite",
  fn: Mi,
  data: {}
};
function Bi(t) {
  var e = t.state;
  Object.keys(e.elements).forEach(function(n) {
    var o = e.styles[n] || {}, r = e.attributes[n] || {}, i = e.elements[n];
    !me(i) || !Ae(i) || (Object.assign(i.style, o), Object.keys(r).forEach(function(a) {
      var l = r[a];
      l === !1 ? i.removeAttribute(a) : i.setAttribute(a, l === !0 ? "" : l);
    }));
  });
}
function Ni(t) {
  var e = t.state, n = {
    popper: {
      position: e.options.strategy,
      left: "0",
      top: "0",
      margin: "0"
    },
    arrow: {
      position: "absolute"
    },
    reference: {}
  };
  return Object.assign(e.elements.popper.style, n.popper), e.styles = n, e.elements.arrow && Object.assign(e.elements.arrow.style, n.arrow), function() {
    Object.keys(e.elements).forEach(function(o) {
      var r = e.elements[o], i = e.attributes[o] || {}, a = Object.keys(e.styles.hasOwnProperty(o) ? e.styles[o] : n[o]), l = a.reduce(function(s, c) {
        return s[c] = "", s;
      }, {});
      !me(r) || !Ae(r) || (Object.assign(r.style, l), Object.keys(i).forEach(function(s) {
        r.removeAttribute(s);
      }));
    });
  };
}
var Ri = {
  name: "applyStyles",
  enabled: !0,
  phase: "write",
  fn: Bi,
  effect: Ni,
  requires: ["computeStyles"]
}, Yi = [ki, Ii, Pi, Ri], ji = /* @__PURE__ */ Oi({
  defaultModifiers: Yi
});
function Vi(t) {
  return t === "x" ? "y" : "x";
}
function Rt(t, e, n) {
  return Re(t, gt(e, n));
}
function Hi(t) {
  var e = t.state, n = t.options, o = t.name, r = n.mainAxis, i = r === void 0 ? !0 : r, a = n.altAxis, l = a === void 0 ? !1 : a, s = n.boundary, c = n.rootBoundary, d = n.altBoundary, u = n.padding, y = n.tether, b = y === void 0 ? !0 : y, p = n.tetherOffset, h = p === void 0 ? 0 : p, m = Bn(e, {
    boundary: s,
    rootBoundary: c,
    padding: u,
    altBoundary: d
  }), T = Se(e.placement), E = nt(e.placement), w = !E, D = Pn(T), S = Vi(D), k = e.modifiersData.popperOffsets, g = e.rects.reference, C = e.rects.popper, v = typeof h == "function" ? h(Object.assign({}, e.rects, {
    placement: e.placement
  })) : h, x = {
    x: 0,
    y: 0
  };
  if (k) {
    if (i || l) {
      var O = D === "y" ? ge : be, V = D === "y" ? _e : Ce, A = D === "y" ? "height" : "width", H = k[D], ie = k[D] + m[O], W = k[D] - m[V], le = b ? -C[A] / 2 : 0, U = E === tt ? g[A] : C[A], J = E === tt ? -C[A] : -g[A], K = e.elements.arrow, ve = b && K ? Ln(K) : {
        width: 0,
        height: 0
      }, Me = e.modifiersData["arrow#persistent"] ? e.modifiersData["arrow#persistent"].padding : Ro(), xt = Me[O], je = Me[V], xe = Rt(0, g[A], ve[A]), Tt = w ? g[A] / 2 - le - xe - xt - v : U - xe - xt - v, Kt = w ? -g[A] / 2 + le + xe + je + v : J + xe + je + v, Xe = e.elements.arrow && Ct(e.elements.arrow), Qt = Xe ? D === "y" ? Xe.clientTop || 0 : Xe.clientLeft || 0 : 0, Yn = e.modifiersData.offset ? e.modifiersData.offset[e.placement][D] : 0, jn = k[D] + Tt - Yn - Qt, Vn = k[D] + Kt - Yn;
      if (i) {
        var Hn = Rt(b ? gt(ie, jn) : ie, H, b ? Re(W, Vn) : W);
        k[D] = Hn, x[D] = Hn - H;
      }
      if (l) {
        var Uo = D === "x" ? ge : be, zo = D === "x" ? _e : Ce, Et = k[S], Wn = Et + m[Uo], Un = Et - m[zo], zn = Rt(b ? gt(Wn, jn) : Wn, Et, b ? Re(Un, Vn) : Un);
        k[S] = zn, x[S] = zn - Et;
      }
    }
    e.modifiersData[o] = x;
  }
}
var Wi = {
  name: "preventOverflow",
  enabled: !0,
  phase: "main",
  fn: Hi,
  requiresIfExists: ["offset"]
}, Ui = {
  left: "right",
  right: "left",
  bottom: "top",
  top: "bottom"
};
function Yt(t) {
  return t.replace(/left|right|bottom|top/g, function(e) {
    return Ui[e];
  });
}
var zi = {
  start: "end",
  end: "start"
};
function ho(t) {
  return t.replace(/start|end/g, function(e) {
    return zi[e];
  });
}
function Xi(t, e) {
  e === void 0 && (e = {});
  var n = e, o = n.placement, r = n.boundary, i = n.rootBoundary, a = n.padding, l = n.flipVariations, s = n.allowedAutoPlacements, c = s === void 0 ? Po : s, d = nt(o), u = d ? l ? uo : uo.filter(function(p) {
    return nt(p) === d;
  }) : Dt, y = u.filter(function(p) {
    return c.indexOf(p) >= 0;
  });
  y.length === 0 && (y = u);
  var b = y.reduce(function(p, h) {
    return p[h] = Bn(t, {
      placement: h,
      boundary: r,
      rootBoundary: i,
      padding: a
    })[Se(h)], p;
  }, {});
  return Object.keys(b).sort(function(p, h) {
    return b[p] - b[h];
  });
}
function qi(t) {
  if (Se(t) === Mn)
    return [];
  var e = Yt(t);
  return [ho(t), e, ho(e)];
}
function Gi(t) {
  var e = t.state, n = t.options, o = t.name;
  if (!e.modifiersData[o]._skip) {
    for (var r = n.mainAxis, i = r === void 0 ? !0 : r, a = n.altAxis, l = a === void 0 ? !0 : a, s = n.fallbackPlacements, c = n.padding, d = n.boundary, u = n.rootBoundary, y = n.altBoundary, b = n.flipVariations, p = b === void 0 ? !0 : b, h = n.allowedAutoPlacements, m = e.options.placement, T = Se(m), E = T === m, w = s || (E || !p ? [Yt(m)] : qi(m)), D = [m].concat(w).reduce(function(je, xe) {
      return je.concat(Se(xe) === Mn ? Xi(e, {
        placement: xe,
        boundary: d,
        rootBoundary: u,
        padding: c,
        flipVariations: p,
        allowedAutoPlacements: h
      }) : xe);
    }, []), S = e.rects.reference, k = e.rects.popper, g = /* @__PURE__ */ new Map(), C = !0, v = D[0], x = 0; x < D.length; x++) {
      var O = D[x], V = Se(O), A = nt(O) === tt, H = [ge, _e].indexOf(V) >= 0, ie = H ? "width" : "height", W = Bn(e, {
        placement: O,
        boundary: d,
        rootBoundary: u,
        altBoundary: y,
        padding: c
      }), le = H ? A ? Ce : be : A ? _e : ge;
      S[ie] > k[ie] && (le = Yt(le));
      var U = Yt(le), J = [];
      if (i && J.push(W[V] <= 0), l && J.push(W[le] <= 0, W[U] <= 0), J.every(function(je) {
        return je;
      })) {
        v = O, C = !1;
        break;
      }
      g.set(O, J);
    }
    if (C)
      for (var K = p ? 3 : 1, ve = function(xe) {
        var Tt = D.find(function(Kt) {
          var Xe = g.get(Kt);
          if (Xe)
            return Xe.slice(0, xe).every(function(Qt) {
              return Qt;
            });
        });
        if (Tt)
          return v = Tt, "break";
      }, Me = K; Me > 0; Me--) {
        var xt = ve(Me);
        if (xt === "break")
          break;
      }
    e.placement !== v && (e.modifiersData[o]._skip = !0, e.placement = v, e.reset = !0);
  }
}
var Ji = {
  name: "flip",
  enabled: !0,
  phase: "main",
  fn: Gi,
  requiresIfExists: ["offset"],
  data: {
    _skip: !1
  }
};
function Ki(t, e, n) {
  var o = Se(t), r = [be, ge].indexOf(o) >= 0 ? -1 : 1, i = typeof n == "function" ? n(Object.assign({}, e, {
    placement: t
  })) : n, a = i[0], l = i[1];
  return a = a || 0, l = (l || 0) * r, [be, Ce].indexOf(o) >= 0 ? {
    x: l,
    y: a
  } : {
    x: a,
    y: l
  };
}
function Qi(t) {
  var e = t.state, n = t.options, o = t.name, r = n.offset, i = r === void 0 ? [0, 0] : r, a = Po.reduce(function(d, u) {
    return d[u] = Ki(u, e.rects, i), d;
  }, {}), l = a[e.placement], s = l.x, c = l.y;
  e.modifiersData.popperOffsets != null && (e.modifiersData.popperOffsets.x += s, e.modifiersData.popperOffsets.y += c), e.modifiersData[o] = a;
}
var Zi = {
  name: "offset",
  enabled: !0,
  phase: "main",
  requires: ["popperOffsets"],
  fn: Qi
}, ea = function(e, n) {
  return e = typeof e == "function" ? e(Object.assign({}, n.rects, {
    placement: n.placement
  })) : e, Yo(typeof e != "number" ? e : jo(e, Dt));
};
function ta(t) {
  var e, n = t.state, o = t.name, r = t.options, i = n.elements.arrow, a = n.modifiersData.popperOffsets, l = Se(n.placement), s = Pn(l), c = [be, Ce].indexOf(l) >= 0, d = c ? "height" : "width";
  if (!(!i || !a)) {
    var u = ea(r.padding, n), y = Ln(i), b = s === "y" ? ge : be, p = s === "y" ? _e : Ce, h = n.rects.reference[d] + n.rects.reference[s] - a[s] - n.rects.popper[d], m = a[s] - n.rects.reference[s], T = Ct(i), E = T ? s === "y" ? T.clientHeight || 0 : T.clientWidth || 0 : 0, w = h / 2 - m / 2, D = u[b], S = E - y[d] - u[p], k = E / 2 - y[d] / 2 + w, g = Rt(D, k, S), C = s;
    n.modifiersData[o] = (e = {}, e[C] = g, e.centerOffset = g - k, e);
  }
}
function na(t) {
  var e = t.state, n = t.options, o = n.element, r = o === void 0 ? "[data-popper-arrow]" : o;
  r != null && (typeof r == "string" && (r = e.elements.popper.querySelector(r), !r) || Bo(e.elements.popper, r) && (e.elements.arrow = r));
}
var oa = {
  name: "arrow",
  enabled: !0,
  phase: "main",
  fn: ta,
  effect: na,
  requires: ["popperOffsets"],
  requiresIfExists: ["preventOverflow"]
};
const pn = (t) => parseInt(t, 10);
function ra({
  arrowPadding: t,
  emit: e,
  locked: n,
  offsetDistance: o,
  offsetSkid: r,
  placement: i,
  popperNode: a,
  triggerNode: l
}) {
  const s = Zo({
    isOpen: !1,
    popperInstance: null
  }), c = (h) => {
    var m;
    (m = s.popperInstance) === null || m === void 0 || m.setOptions((T) => ({
      ...T,
      modifiers: [...T.modifiers, {
        name: "eventListeners",
        enabled: h
      }]
    }));
  }, d = () => c(!0), u = () => c(!1), y = () => {
    s.isOpen && (s.isOpen = !1, e("close:popper"));
  }, b = () => {
    s.isOpen || (s.isOpen = !0, e("open:popper"));
  };
  vt([() => s.isOpen, i], async ([h]) => {
    h ? (await p(), d()) : u();
  });
  const p = async () => {
    await yo(), s.popperInstance = ji(l.value, a.value, {
      placement: i.value,
      modifiers: [Wi, Ji, {
        name: "flip",
        enabled: !n.value
      }, oa, {
        name: "arrow",
        options: {
          padding: pn(t.value)
        }
      }, Zi, {
        name: "offset",
        options: {
          offset: [pn(r.value), pn(o.value)]
        }
      }]
    }), s.popperInstance.update();
  };
  return zt(() => {
    var h;
    (h = s.popperInstance) === null || h === void 0 || h.destroy();
  }), {
    ...go(s),
    open: b,
    close: y
  };
}
const ia = {
  id: "arrow",
  "data-popper-arrow": ""
};
function aa(t, e) {
  return L(), M("div", ia);
}
function Vo(t, e) {
  e === void 0 && (e = {});
  var n = e.insertAt;
  if (!(!t || typeof document > "u")) {
    var o = document.head || document.getElementsByTagName("head")[0], r = document.createElement("style");
    r.type = "text/css", n === "top" && o.firstChild ? o.insertBefore(r, o.firstChild) : o.appendChild(r), r.styleSheet ? r.styleSheet.cssText = t : r.appendChild(document.createTextNode(t));
  }
}
var la = `
#arrow[data-v-20b7fd4a],
  #arrow[data-v-20b7fd4a]::before {
    transition: background 250ms ease-in-out;
    position: absolute;
    width: calc(10px - var(--popper-theme-border-width, 0px));
    height: calc(10px - var(--popper-theme-border-width, 0px));
    box-sizing: border-box;
    background: var(--popper-theme-background-color);
}
#arrow[data-v-20b7fd4a] {
    visibility: hidden;
}
#arrow[data-v-20b7fd4a]::before {
    visibility: visible;
    content: "";
    transform: rotate(45deg);
}

  /* Top arrow */
.popper[data-popper-placement^="top"] > #arrow[data-v-20b7fd4a] {
    bottom: -5px;
}
.popper[data-popper-placement^="top"] > #arrow[data-v-20b7fd4a]::before {
    border-right: var(--popper-theme-border-width)
      var(--popper-theme-border-style) var(--popper-theme-border-color);
    border-bottom: var(--popper-theme-border-width)
      var(--popper-theme-border-style) var(--popper-theme-border-color);
}

  /* Bottom arrow */
.popper[data-popper-placement^="bottom"] > #arrow[data-v-20b7fd4a] {
    top: -5px;
}
.popper[data-popper-placement^="bottom"] > #arrow[data-v-20b7fd4a]::before {
    border-left: var(--popper-theme-border-width)
      var(--popper-theme-border-style) var(--popper-theme-border-color);
    border-top: var(--popper-theme-border-width)
      var(--popper-theme-border-style) var(--popper-theme-border-color);
}

  /* Left arrow */
.popper[data-popper-placement^="left"] > #arrow[data-v-20b7fd4a] {
    right: -5px;
}
.popper[data-popper-placement^="left"] > #arrow[data-v-20b7fd4a]::before {
    border-right: var(--popper-theme-border-width)
      var(--popper-theme-border-style) var(--popper-theme-border-color);
    border-top: var(--popper-theme-border-width)
      var(--popper-theme-border-style) var(--popper-theme-border-color);
}

  /* Right arrow */
.popper[data-popper-placement^="right"] > #arrow[data-v-20b7fd4a] {
    left: -5px;
}
`;
Vo(la);
const Nn = {};
Nn.render = aa;
Nn.__scopeId = "data-v-20b7fd4a";
var sa = Nn;
const ua = ["onKeyup"];
var Ho = {
  props: {
    /**
     * Preferred placement (the "auto" placements will choose the side with most space.)
     */
    placement: {
      type: String,
      default: "bottom",
      validator: function(t) {
        return ["auto", "auto-start", "auto-end", "top", "top-start", "top-end", "bottom", "bottom-start", "bottom-end", "right", "right-start", "right-end", "left", "left-start", "left-end"].includes(t);
      }
    },
    /**
     * Disables automatically closing the popover when the user clicks away from it
     */
    disableClickAway: {
      type: Boolean,
      default: !1
    },
    /**
     * Offset in pixels along the trigger element
     */
    offsetSkid: {
      type: String,
      default: "0"
    },
    /**
     * Offset in pixels away from the trigger element
     */
    offsetDistance: {
      type: String,
      default: "12"
    },
    /**
     * Trigger the popper on hover
     */
    hover: {
      type: Boolean,
      default: !1
    },
    /**
     * Manually open/close the Popper, other events are ignored if this prop is set
     */
    show: {
      type: Boolean,
      default: null
    },
    /**
     * Disables the Popper. If it was already open, it will be closed.
     */
    disabled: {
      type: Boolean,
      default: !1
    },
    /**
     * Open the Popper after a delay (ms).
     */
    openDelay: {
      type: [Number, String],
      default: 0
    },
    /**
     * Close the Popper after a delay (ms).
     */
    closeDelay: {
      type: [Number, String],
      default: 0
    },
    /**
     * The z-index of the Popper.
     */
    zIndex: {
      type: [Number, String],
      default: 9999
    },
    /**
     * Display an arrow on the popper
     */
    arrow: {
      type: Boolean,
      default: !1
    },
    /**
     * Stop arrow from reaching the edge of the popper
     */
    arrowPadding: {
      type: String,
      default: "0"
    },
    /**
     * If the Popper should be interactive, it will close when clicked/hovered if false
     */
    interactive: {
      type: Boolean,
      default: !0
    },
    /**
     * Lock the Popper into place, it will not flip dynamically when it runs out of space if true
     */
    locked: {
      type: Boolean,
      default: !1
    },
    /**
     * If the content is just a simple string, it can be passed in as a prop
     */
    content: {
      type: String,
      default: null
    }
  },
  emits: ["open:popper", "close:popper"],
  setup(t, {
    emit: e
  }) {
    const n = t;
    qo((U) => ({
      c81fc0a4: t.zIndex
    }));
    const o = Go(), r = ue(null), i = ue(null), a = ue(null), l = ue(!1);
    yt(() => {
      const U = o.default();
      if (U && U.length > 1)
        return console.error(`[Popper]: The <Popper> component expects only one child element at its root. You passed ${U.length} child nodes.`);
    });
    const {
      arrowPadding: s,
      closeDelay: c,
      content: d,
      disableClickAway: u,
      disabled: y,
      interactive: b,
      locked: p,
      offsetDistance: h,
      offsetSkid: m,
      openDelay: T,
      placement: E,
      show: w
    } = go(n), {
      isOpen: D,
      open: S,
      close: k
    } = ra({
      arrowPadding: s,
      emit: e,
      locked: p,
      offsetDistance: h,
      offsetSkid: m,
      placement: E,
      popperNode: i,
      triggerNode: a
    }), {
      hasContent: g
    } = ei(o, i, d), C = z(() => w.value !== null), v = z(() => y.value || !g.value), x = z(() => D.value && !v.value), O = z(() => !u.value && !C.value), V = z(() => b.value ? `border: ${h.value}px solid transparent; margin: -${h.value}px;` : null), A = fn.debounce(S, T.value), H = fn.debounce(k, c.value), ie = async () => {
      v.value || C.value || (H.clear(), A());
    }, W = async () => {
      C.value || (A.clear(), H());
    }, le = () => {
      D.value ? W() : ie();
    };
    return vt([g, y], ([U, J]) => {
      D.value && (!U || J) && k();
    }), vt(D, (U) => {
      U ? l.value = !0 : fn.debounce(() => {
        l.value = !1;
      }, 200);
    }), qn(() => {
      C.value && (w.value ? A() : H());
    }), qn(() => {
      O.value && Zr(r, W);
    }), (U, J) => (L(), M("div", {
      class: "inline-block",
      style: ze(ee(V)),
      onMouseleave: J[2] || (J[2] = (K) => t.hover && W()),
      ref: (K, ve) => {
        ve.popperContainerNode = K, r.value = K;
      }
    }, [f("div", {
      ref: (K, ve) => {
        ve.triggerNode = K, a.value = K;
      },
      onMouseover: J[0] || (J[0] = (K) => t.hover && ie()),
      onClick: le,
      onFocus: ie,
      onKeyup: Jo(W, ["esc"])
    }, [hn(U.$slots, "default")], 40, ua), Ue(Ko, {
      name: "fade"
    }, {
      default: Ft(() => [fe(f("div", {
        onClick: J[1] || (J[1] = (K) => !ee(b) && W()),
        class: "popper",
        ref: (K, ve) => {
          ve.popperNode = K, i.value = K;
        }
      }, [hn(U.$slots, "content", {
        close: ee(k),
        isOpen: l.value
      }, () => [lt(we(ee(d)), 1)]), t.arrow ? (L(), Qo(sa, {
        key: 0
      })) : Tn("", !0)], 512), [[bo, ee(x)]])]),
      _: 3
    })], 36));
  }
}, ca = `
.inline-block[data-v-5784ed69] {
    display: inline-block;
}
.popper[data-v-5784ed69] {
    transition: background 250ms ease-in-out;
    background: var(--popper-theme-background-color);
    padding: var(--popper-theme-padding);
    color: var(--popper-theme-text-color);
    border-radius: var(--popper-theme-border-radius);
    border-width: var(--popper-theme-border-width);
    border-style: var(--popper-theme-border-style);
    border-color: var(--popper-theme-border-color);
    box-shadow: var(--popper-theme-box-shadow);
    z-index: var(--c81fc0a4);
}
.popper[data-v-5784ed69]:hover,
  .popper:hover > #arrow[data-v-5784ed69]::before {
    background: var(--popper-theme-background-color-hover);
}
.inline-block[data-v-5784ed69] {
    display: inline-block;
}
.fade-enter-active[data-v-5784ed69],
  .fade-leave-active[data-v-5784ed69] {
    transition: opacity 0.2s ease;
}
.fade-enter-from[data-v-5784ed69],
  .fade-leave-to[data-v-5784ed69] {
    opacity: 0;
}
`;
Vo(ca);
Ho.__scopeId = "data-v-5784ed69";
var da = /* @__PURE__ */ (() => {
  const t = Ho;
  return t.install = (e) => {
    e.component("Popper", t);
  }, t;
})();
const fa = (t) => {
  try {
    return JSON.parse(t);
  } catch {
    return null;
  }
}, pa = "data:image/svg+xml,%3csvg%20xmlns='http://www.w3.org/2000/svg'%20width='24'%20height='24'%20viewBox='0%200%2024%2024'%20fill='none'%20stroke='currentColor'%20stroke-width='2'%20stroke-linecap='round'%20stroke-linejoin='round'%20%3e%3cline%20x1='17'%20y1='10'%20x2='3'%20y2='10'%20/%3e%3cline%20x1='21'%20y1='6'%20x2='3'%20y2='6'%20/%3e%3cline%20x1='21'%20y1='14'%20x2='3'%20y2='14'%20/%3e%3cline%20x1='17'%20y1='18'%20x2='3'%20y2='18'%20/%3e%3c/svg%3e", va = "data:image/svg+xml,%3csvg%20xmlns='http://www.w3.org/2000/svg'%20xml:space='preserve'%20width='96'%20height='96'%3e%3cpath%20d='M12%2028h72a4%204%200%200%200%200-8H12a4%204%200%200%200%200%208zm8%208a4%204%200%200%200%200%208h56a4%204%200%200%200%200-8H20zm64%2016H12a4%204%200%200%200%200%208h72a4%204%200%200%200%200-8zm-8%2016H20a4%204%200%200%200%200%208h56a4%204%200%200%200%200-8z'/%3e%3c/svg%3e", ha = "data:image/svg+xml,%3csvg%20xmlns='http://www.w3.org/2000/svg'%20xml:space='preserve'%20width='96'%20height='96'%3e%3cpath%20d='M88%2024a4%204%200%200%200-4-4H12a4%204%200%200%200%200%208h72a4%204%200%200%200%204-4zm0%2016a4%204%200%200%200-4-4H28a4%204%200%200%200%200%208h56a4%204%200%200%200%204-4zM8%2056a4%204%200%200%200%204%204h72a4%204%200%200%200%200-8H12a4%204%200%200%200-4%204zm16%2016a4%204%200%200%200%204%204h56a4%204%200%200%200%200-8H28a4%204%200%200%200-4%204z'/%3e%3c/svg%3e", ma = "data:image/svg+xml,%3csvg%20xmlns='http://www.w3.org/2000/svg'%20width='24'%20height='24'%20viewBox='0%200%2024%2024'%3e%3cpath%20d='M8%2011h3v10h2V11h3l-4-4-4%204zM4%203v2h16V3H4z'/%3e%3c/svg%3e", ga = "data:image/svg+xml,%3csvg%20xmlns='http://www.w3.org/2000/svg'%20width='24'%20height='24'%20viewBox='0%200%2024%2024'%3e%3cpath%20d='M8%2019h3v4h2v-4h3l-4-4-4%204zm8-14h-3V1h-2v4H8l4%204%204-4zM4%2011v2h16v-2H4z'/%3e%3c/svg%3e", ba = "data:image/svg+xml,%3csvg%20xmlns='http://www.w3.org/2000/svg'%20width='24'%20height='24'%20viewBox='0%200%2024%2024'%3e%3cpath%20d='M16%2013h-3V3h-2v10H8l4%204%204-4zM4%2019v2h16v-2H4z'/%3e%3c/svg%3e", Q = [];
for (let t = 0; t < 256; ++t)
  Q.push((t + 256).toString(16).slice(1));
function ya(t, e = 0) {
  return (Q[t[e + 0]] + Q[t[e + 1]] + Q[t[e + 2]] + Q[t[e + 3]] + "-" + Q[t[e + 4]] + Q[t[e + 5]] + "-" + Q[t[e + 6]] + Q[t[e + 7]] + "-" + Q[t[e + 8]] + Q[t[e + 9]] + "-" + Q[t[e + 10]] + Q[t[e + 11]] + Q[t[e + 12]] + Q[t[e + 13]] + Q[t[e + 14]] + Q[t[e + 15]]).toLowerCase();
}
let vn;
const wa = new Uint8Array(16);
function _a() {
  if (!vn) {
    if (typeof crypto > "u" || !crypto.getRandomValues)
      throw new Error("crypto.getRandomValues() not supported. See https://github.com/uuidjs/uuid#getrandomvalues-not-supported");
    vn = crypto.getRandomValues.bind(crypto);
  }
  return vn(wa);
}
const Ca = typeof crypto < "u" && crypto.randomUUID && crypto.randomUUID.bind(crypto), mo = { randomUUID: Ca };
function Wo(t, e, n) {
  var r;
  if (mo.randomUUID && !e && !t)
    return mo.randomUUID();
  t = t || {};
  const o = t.random ?? ((r = t.rng) == null ? void 0 : r.call(t)) ?? _a();
  if (o.length < 16)
    throw new Error("Random bytes length must be >= 16");
  if (o[6] = o[6] & 15 | 64, o[8] = o[8] & 63 | 128, e) {
    if (n = n || 0, n < 0 || n + 16 > e.length)
      throw new RangeError(`UUID byte range ${n}:${n + 15} is out of buffer bounds`);
    for (let i = 0; i < 16; ++i)
      e[n + i] = o[i];
    return e;
  }
  return ya(o);
}
const Jt = (t) => (En("data-v-52705289"), t = t(), Sn(), t), Da = {
  key: 0,
  class: "popup-edit-label"
}, xa = { class: "popup-content" }, Ta = { class: "input-group" }, Ea = /* @__PURE__ */ Jt(() => /* @__PURE__ */ f("label", null, "Tiêu đề:", -1)), Sa = { class: "input-group" }, Oa = /* @__PURE__ */ Jt(() => /* @__PURE__ */ f("label", null, "Màu chữ:", -1)), Aa = { class: "color-picker" }, ka = { class: "color-input-group" }, $a = { class: "quick-colors" }, Ia = ["onClick"], Fa = { class: "input-group" }, La = /* @__PURE__ */ Jt(() => /* @__PURE__ */ f("label", null, "Màu nền:", -1)), Ma = { class: "color-picker" }, Pa = { class: "color-input-group" }, Ba = { class: "quick-colors" }, Na = ["onClick"], Ra = { class: "input-group" }, Ya = /* @__PURE__ */ Jt(() => /* @__PURE__ */ f("label", null, "Style:", -1)), ja = { class: "style-buttons" }, Va = { class: "actions" }, Ha = ["disabled"], Wa = /* @__PURE__ */ bt({
  __name: "PopupEditLabel",
  emits: ["save"],
  setup(t, { expose: e, emit: n }) {
    const o = n, r = ue(), i = ue(!1), a = ue({
      title: "",
      code: "",
      style: {
        color: "#000000",
        backgroundColor: "#ffffff",
        fontWeight: "normal",
        fontStyle: "normal",
        textDecoration: "none"
      }
    }), l = [
      "#000000",
      "#ffffff",
      "#ff0000",
      "#00ff00",
      "#0000ff",
      "#ffff00",
      "#ff00ff",
      "#00ffff",
      "#ffa500",
      "#800080"
    ], s = [
      "#000000",
      "#ffffff",
      "#ff0000",
      "#00ff00",
      "#0000ff",
      "#ffff00",
      "#ff00ff",
      "#00ffff",
      "#ffa500",
      "#800080",
      "transparent"
    ], c = (b) => {
      if (a.value.style)
        switch (b) {
          case "fontWeight":
            a.value.style.fontWeight = a.value.style.fontWeight === "bold" ? "normal" : "bold";
            break;
          case "fontStyle":
            a.value.style.fontStyle = a.value.style.fontStyle === "italic" ? "normal" : "italic";
            break;
          case "textDecoration":
            a.value.style.textDecoration = a.value.style.textDecoration === "underline" ? "none" : "underline";
            break;
        }
    }, d = () => {
      i.value = !1;
    }, u = () => {
      o("save", a.value), i.value = !1;
    };
    return e({
      show: (b) => {
        var p, h, m, T, E;
        i.value = !0, b ? a.value = {
          title: b.title,
          code: b.code,
          style: {
            color: ((p = b.style) == null ? void 0 : p.color) || "#000000",
            backgroundColor: ((h = b.style) == null ? void 0 : h.backgroundColor) || "transparent",
            fontWeight: ((m = b.style) == null ? void 0 : m.fontWeight) || "normal",
            fontStyle: ((T = b.style) == null ? void 0 : T.fontStyle) || "normal",
            textDecoration: ((E = b.style) == null ? void 0 : E.textDecoration) || "none"
          }
        } : a.value = {
          title: "",
          code: Wo(),
          style: {
            color: "#000000",
            backgroundColor: "transparent",
            fontWeight: "normal",
            fontStyle: "normal",
            textDecoration: "none"
          }
        }, yo(() => {
          var w;
          (w = r.value) == null || w.focus();
        });
      }
    }), (b, p) => i.value ? (L(), M("div", Da, [
      f("div", xa, [
        f("div", Ta, [
          Ea,
          fe(f("input", {
            ref_key: "inputTitleRef",
            ref: r,
            class: "input-title",
            "onUpdate:modelValue": p[0] || (p[0] = (h) => a.value.title = h),
            type: "text",
            placeholder: "Nhập tiêu đề..."
          }, null, 512), [
            [ke, a.value.title]
          ])
        ]),
        f("div", Sa, [
          Oa,
          f("div", Aa, [
            f("div", ka, [
              fe(f("input", {
                "onUpdate:modelValue": p[1] || (p[1] = (h) => a.value.style.color = h),
                type: "color"
              }, null, 512), [
                [ke, a.value.style.color]
              ]),
              fe(f("input", {
                "onUpdate:modelValue": p[2] || (p[2] = (h) => a.value.style.color = h),
                type: "text",
                class: "hex-input",
                placeholder: "#000000"
              }, null, 512), [
                [ke, a.value.style.color]
              ])
            ]),
            f("div", $a, [
              (L(), M(ne, null, oe(l, (h) => f("button", {
                key: h,
                style: ze({ backgroundColor: h }),
                onClick: (m) => a.value.style.color = h
              }, null, 12, Ia)), 64))
            ])
          ])
        ]),
        f("div", Fa, [
          La,
          f("div", Ma, [
            f("div", Pa, [
              fe(f("input", {
                "onUpdate:modelValue": p[3] || (p[3] = (h) => a.value.style.backgroundColor = h),
                type: "color"
              }, null, 512), [
                [ke, a.value.style.backgroundColor]
              ]),
              fe(f("input", {
                "onUpdate:modelValue": p[4] || (p[4] = (h) => a.value.style.backgroundColor = h),
                type: "text",
                class: "hex-input",
                placeholder: "#ffffff"
              }, null, 512), [
                [ke, a.value.style.backgroundColor]
              ])
            ]),
            f("div", Ba, [
              (L(), M(ne, null, oe(s, (h) => f("button", {
                key: h,
                style: ze({ backgroundColor: h }),
                onClick: (m) => a.value.style.backgroundColor = h
              }, null, 12, Na)), 64))
            ])
          ])
        ]),
        f("div", Ra, [
          Ya,
          f("div", ja, [
            f("button", {
              class: q({ active: a.value.style.fontWeight === "bold" }),
              onClick: p[5] || (p[5] = (h) => c("fontWeight"))
            }, " B ", 2),
            f("button", {
              class: q({ active: a.value.style.fontStyle === "italic" }),
              onClick: p[6] || (p[6] = (h) => c("fontStyle"))
            }, " I ", 2),
            f("button", {
              class: q({ active: a.value.style.textDecoration === "underline" }),
              onClick: p[7] || (p[7] = (h) => c("textDecoration"))
            }, " U ", 2)
          ])
        ]),
        f("div", Va, [
          f("button", {
            class: "btn-cancel",
            onClick: d
          }, "Hủy"),
          f("button", {
            class: "btn-save",
            onClick: u,
            disabled: !a.value.title
          }, "Lưu", 8, Ha)
        ])
      ])
    ])) : Tn("", !0);
  }
}), Ua = /* @__PURE__ */ Xt(Wa, [["__scopeId", "data-v-52705289"]]), re = (t) => (En("data-v-5653446d"), t = t(), Sn(), t), za = { class: "grid-col-2" }, Xa = { class: "edit-columns" }, qa = { class: "justify-content-space-between" }, Ga = /* @__PURE__ */ re(() => /* @__PURE__ */ f("h5", null, " Columns ", -1)), Ja = ["disabled"], Ka = /* @__PURE__ */ re(() => /* @__PURE__ */ f("hr", { style: { margin: "5px 0" } }, null, -1)), Qa = ["onClick"], Za = ["onDrop", "onDragover", "onDragleave"], el = { class: "align-items-center" }, tl = /* @__PURE__ */ re(() => /* @__PURE__ */ f("span", { class: "handle" }, "☰", -1)), nl = ["disabled"], ol = { class: "popover-action" }, rl = ["onClick"], il = ["src"], al = ["onClick"], ll = ["src"], sl = ["onClick"], ul = ["src"], cl = { style: { "margin-top": "4px" } }, dl = ["onClick"], fl = ["src"], pl = ["onClick"], vl = ["src"], hl = ["onClick"], ml = ["src"], gl = {
  style: { "margin-top": "4px" },
  class: "div-input"
}, bl = /* @__PURE__ */ re(() => /* @__PURE__ */ f("label", { class: "label" }, "width:", -1)), yl = ["onUpdate:modelValue"], wl = {
  style: { "margin-top": "4px" },
  class: "div-input"
}, _l = /* @__PURE__ */ re(() => /* @__PURE__ */ f("label", { class: "label" }, "min-width:", -1)), Cl = ["onUpdate:modelValue"], Dl = {
  style: { "margin-top": "4px" },
  class: "div-input"
}, xl = /* @__PURE__ */ re(() => /* @__PURE__ */ f("label", { class: "label" }, "max-width:", -1)), Tl = ["onUpdate:modelValue"], El = ["disabled", "onUpdate:modelValue"], Sl = { class: "list-selected-field" }, Ol = ["src"], Al = { key: 1 }, kl = { class: "no-data" }, $l = ["onClick", "disabled"], Il = { class: "edit-columns" }, Fl = /* @__PURE__ */ re(() => /* @__PURE__ */ f("h5", null, "Fields", -1)), Ll = /* @__PURE__ */ re(() => /* @__PURE__ */ f("hr", { style: { margin: "5px 0" } }, null, -1)), Ml = { class: "list-field custom-scroll" }, Pl = { class: "label" }, Bl = ["onDragstart", "onDblclick"], Nl = { class: "edit-columns etc-field custom-scroll" }, Rl = /* @__PURE__ */ re(() => /* @__PURE__ */ f("h5", null, "Separator", -1)), Yl = /* @__PURE__ */ re(() => /* @__PURE__ */ f("hr", { style: { margin: "5px 0" } }, null, -1)), jl = { class: "list-field-symbol" }, Vl = ["onDblclick", "onDragstart"], Hl = { style: { "margin-top": "10px" } }, Wl = /* @__PURE__ */ re(() => /* @__PURE__ */ f("h5", null, "Actions", -1)), Ul = /* @__PURE__ */ re(() => /* @__PURE__ */ f("hr", { style: { margin: "5px 0" } }, null, -1)), zl = { class: "list-field-symbol" }, Xl = ["onDblclick", "onDragstart"], ql = { style: { "margin-top": "10px" } }, Gl = { class: "justify-content-space-between" }, Jl = /* @__PURE__ */ re(() => /* @__PURE__ */ f("h5", null, " Labels ", -1)), Kl = ["disabled"], Ql = /* @__PURE__ */ re(() => /* @__PURE__ */ f("hr", { style: { margin: "5px 0" } }, null, -1)), Zl = { class: "list-field-symbol" }, es = ["onClick", "onDblclick", "onDragstart"], ts = { style: { "margin-top": "10px" } }, ns = /* @__PURE__ */ re(() => /* @__PURE__ */ f("h5", null, "Icons", -1)), os = /* @__PURE__ */ re(() => /* @__PURE__ */ f("hr", { style: { margin: "5px 0" } }, null, -1)), rs = { class: "list-field-symbol" }, is = ["onDblclick", "src", "onDragstart"], as = /* @__PURE__ */ bt({
  __name: "TableEditor",
  props: {
    modelValue: {},
    labels: {},
    vfFields: { default: () => [] },
    actions: { default: () => [] },
    icons: { default: () => [] },
    height: { default: 390 },
    disabled: { type: Boolean, default: !1 }
  },
  emits: ["update:modelValue", "update:labels", "error"],
  setup(t, { emit: e }) {
    const n = t, o = e, r = z({
      get() {
        return n.modelValue;
      },
      set(g) {
        o("update:modelValue", g);
      }
    }), i = z({
      get() {
        return n.labels || [];
      },
      set(g) {
        o("update:labels", g);
      }
    }), a = z(() => i.value.map((g) => ({
      vfCode: g.code,
      vfTitle: g.title,
      vfType: P.LABEL,
      vfAcutalField: g.code,
      vfActualFieldTitle: g.title
    }))), l = z(() => [...mn, ...n.actions, ...n.icons, ...n.vfFields, ...a.value]), s = z(() => l.value.reduce((g, C) => (g[C.vfCode] = C, g), {})), c = ue(-1), d = z(() => {
      const g = {}, C = [];
      for (const v of n.vfFields) {
        const x = (v == null ? void 0 : v.vfAcutalField) || "";
        g[x] === void 0 ? (C.push({
          title: v.vfActualFieldTitle || "",
          field: x,
          variants: [v]
        }), g[x] = C.length - 1) : C[g[x]].variants.push(v);
      }
      return C;
    }), u = () => {
      o("update:modelValue", [
        ...n.modelValue,
        {
          title: "",
          fieldCodes: [],
          isDrag: !1
        }
      ]);
    }, y = (g, C) => {
      g.dataTransfer.setData("text", JSON.stringify(C));
    }, b = (g, C) => {
      if (n.disabled)
        return !1;
      g.preventDefault(), C.isDrag = !0;
    }, p = (g, C) => {
      if (n.disabled)
        return !1;
      g.preventDefault(), C.isDrag = !1;
    }, h = (g, C, v) => {
      if (n.disabled)
        return !1;
      g.preventDefault();
      const x = fa(g.dataTransfer.getData("text"));
      x && x.vfCode && C.fieldCodes.push(x.vfCode), C.isDrag = !1, c.value = v;
    }, m = (g) => {
      const C = n.modelValue, v = C[g];
      v.fieldCodes.length > 0 ? v.fieldCodes.pop() : (C.splice(g, 1), c.value = -1), o("update:modelValue", C);
    }, T = (g) => {
      if (!n.disabled)
        if (c.value >= 0) {
          const C = r.value[c.value];
          C && C.fieldCodes.push(g.vfCode);
        } else
          o("error", "Hãy chọn column để thêm");
    }, E = ue(), w = z(() => (g) => {
      const C = i.value.find((v) => v.code === g.vfCode);
      return (C == null ? void 0 : C.style) || {};
    }), D = () => {
      var g;
      (g = E.value) == null || g.show();
    }, S = (g) => {
      var v;
      const C = i.value.find((x) => x.code === g.vfCode);
      C && ((v = E.value) == null || v.show(C));
    }, k = (g) => {
      console.log("handleSaveLabel", g);
      const C = i.value.find((v) => v.code === g.code);
      C ? (C.title = g.title, C.style = g.style) : i.value.push(g), o("update:labels", i.value);
    };
    return (g, C) => (L(), M("div", {
      class: "dynamic-table-edit box box-grid",
      style: ze({ height: `${g.height}px` })
    }, [
      f("div", za, [
        f("div", Xa, [
          f("div", qa, [
            Ga,
            f("div", null, [
              f("button", {
                class: "btn-plus",
                disabled: g.disabled,
                onClick: u
              }, "✚", 8, Ja)
            ])
          ]),
          Ka,
          Ue(ee(Kr), {
            tag: "ul",
            modelValue: r.value,
            "onUpdate:modelValue": C[0] || (C[0] = (v) => r.value = v),
            handle: ".handle",
            "ghost-class": "ghost",
            sort: !g.disabled,
            class: "dragArea list-group custom-scroll"
          }, {
            default: Ft(() => [
              (L(!0), M(ne, null, oe(r.value, (v, x) => (L(), M("li", {
                key: x,
                class: q(["list-group-item", { hover: v.isDrag, active: c.value === x }]),
                onClick: (O) => !g.disabled && (c.value = x)
              }, [
                f("div", {
                  class: "label align-items-center",
                  onDrop: (O) => h(O, v, x),
                  onDragover: (O) => b(O, v),
                  onDragleave: (O) => p(O, v)
                }, [
                  f("div", el, [
                    tl,
                    Ue(ee(da), {
                      placement: "right-start",
                      arrow: "",
                      class: "popper-wrapper"
                    }, {
                      content: Ft(() => [
                        f("div", ol, [
                          f("div", null, [
                            f("button", {
                              class: q(["btn-more", { active: (v.align || "left") === "left" }]),
                              onClick: (O) => v.align = "left"
                            }, [
                              f("img", { src: ee(pa) }, null, 8, il)
                            ], 10, rl),
                            f("button", {
                              class: q(["btn-more", { active: v.align === "center" }]),
                              onClick: (O) => v.align = "center"
                            }, [
                              f("img", { src: ee(va) }, null, 8, ll)
                            ], 10, al),
                            f("button", {
                              class: q(["btn-more", { active: v.align === "right" }]),
                              onClick: (O) => v.align = "right"
                            }, [
                              f("img", { src: ee(ha) }, null, 8, ul)
                            ], 10, sl)
                          ]),
                          f("div", cl, [
                            f("button", {
                              class: q(["btn-more", { active: (v.vAlign || "top") === "top" }]),
                              onClick: (O) => v.vAlign = "top"
                            }, [
                              f("img", { src: ee(ma) }, null, 8, fl)
                            ], 10, dl),
                            f("button", {
                              class: q(["btn-more", { active: v.vAlign === "middle" }]),
                              onClick: (O) => v.vAlign = "middle"
                            }, [
                              f("img", { src: ee(ga) }, null, 8, vl)
                            ], 10, pl),
                            f("button", {
                              class: q(["btn-more", { active: v.vAlign === "bottom" }]),
                              onClick: (O) => v.vAlign = "bottom"
                            }, [
                              f("img", { src: ee(ba) }, null, 8, ml)
                            ], 10, hl)
                          ]),
                          f("div", gl, [
                            bl,
                            lt(),
                            fe(f("input", {
                              type: "text",
                              "onUpdate:modelValue": (O) => v.width = O,
                              placeholder: "# px | %"
                            }, null, 8, yl), [
                              [ke, v.width]
                            ])
                          ]),
                          f("div", wl, [
                            _l,
                            lt(),
                            fe(f("input", {
                              type: "text",
                              "onUpdate:modelValue": (O) => v.minWidth = O,
                              placeholder: "# px | %"
                            }, null, 8, Cl), [
                              [ke, v.minWidth]
                            ])
                          ]),
                          f("div", Dl, [
                            xl,
                            lt(),
                            fe(f("input", {
                              type: "text",
                              "onUpdate:modelValue": (O) => v.maxWidth = O,
                              placeholder: "# px | %"
                            }, null, 8, Tl), [
                              [ke, v.maxWidth]
                            ])
                          ])
                        ])
                      ]),
                      default: Ft(() => [
                        f("button", {
                          class: "btn-more",
                          disabled: g.disabled
                        }, "⋯", 8, nl)
                      ]),
                      _: 2
                    }, 1024),
                    fe(f("input", {
                      disabled: g.disabled,
                      class: "input-title",
                      type: "text",
                      "onUpdate:modelValue": (O) => v.title = O,
                      placeholder: "Column name"
                    }, null, 8, El), [
                      [ke, v.title]
                    ])
                  ]),
                  f("ul", Sl, [
                    (L(!0), M(ne, null, oe(v.fieldCodes, (O) => {
                      var V, A, H;
                      return L(), M("li", { key: O }, [
                        ((V = s.value[O]) == null ? void 0 : V.vfType) === ee(P).ICON ? (L(), M("img", {
                          key: 0,
                          class: "icon-selected",
                          src: (A = s.value[O]) == null ? void 0 : A.value
                        }, null, 8, Ol)) : (L(), M("span", Al, we((H = s.value[O]) == null ? void 0 : H.vfTitle), 1))
                      ]);
                    }), 128)),
                    fe(f("li", kl, "Kéo field vào đây", 512), [
                      [bo, !v.fieldCodes.length]
                    ])
                  ])
                ], 40, Za),
                f("div", null, [
                  f("button", {
                    class: "btn btn-close",
                    onClick: tr((O) => m(x), ["stop"]),
                    disabled: g.disabled
                  }, " ✘ ", 8, $l)
                ])
              ], 10, Qa))), 128))
            ]),
            _: 1
          }, 8, ["modelValue", "sort"])
        ]),
        f("div", Il, [
          Fl,
          Ll,
          f("ul", Ml, [
            (L(!0), M(ne, null, oe(d.value, (v) => (L(), M("li", {
              key: v.field
            }, [
              f("div", Pl, we(v.title) + ":", 1),
              (L(!0), M(ne, null, oe(v.variants, (x) => (L(), M("div", {
                class: q(["item", { disabled: g.disabled }]),
                draggable: "true",
                onDragstart: (O) => y(O, x),
                key: x.vfCode,
                onDblclick: (O) => T(x)
              }, we(x.vfTitle), 43, Bl))), 128))
            ]))), 128))
          ])
        ]),
        f("div", Nl, [
          f("div", null, [
            Rl,
            Yl,
            f("ul", jl, [
              (L(!0), M(ne, null, oe(ee(mn), (v) => (L(), M("li", {
                key: v.vfAcutalField
              }, [
                f("div", {
                  onDblclick: (x) => T(v),
                  class: q(["item", { disabled: g.disabled }]),
                  draggable: "true",
                  onDragstart: (x) => y(x, v)
                }, we(v.vfTitle), 43, Vl)
              ]))), 128))
            ])
          ]),
          f("div", Hl, [
            Wl,
            Ul,
            f("ul", zl, [
              (L(!0), M(ne, null, oe(g.actions, (v) => (L(), M("li", {
                key: v.vfAcutalField
              }, [
                f("div", {
                  onDblclick: (x) => T(v),
                  class: q(["item btn", { disabled: g.disabled }]),
                  draggable: "true",
                  onDragstart: (x) => y(x, v)
                }, we(v.vfTitle), 43, Xl)
              ]))), 128))
            ])
          ]),
          f("div", ql, [
            f("div", Gl, [
              Jl,
              f("div", null, [
                f("button", {
                  class: "btn-plus",
                  disabled: g.disabled,
                  onClick: D
                }, "✚", 8, Kl)
              ])
            ]),
            Ql,
            f("ul", Zl, [
              (L(!0), M(ne, null, oe(a.value, (v) => (L(), M("li", {
                key: v.vfCode
              }, [
                f("div", {
                  onClick: (x) => !g.disabled && S(v),
                  style: ze(w.value(v)),
                  onDblclick: (x) => T(v),
                  class: q(["item btn", { disabled: g.disabled }]),
                  draggable: "true",
                  onDragstart: (x) => y(x, v)
                }, we(v.vfTitle), 47, es)
              ]))), 128))
            ])
          ]),
          f("div", ts, [
            ns,
            os,
            f("ul", rs, [
              (L(!0), M(ne, null, oe(g.icons, (v) => (L(), M("li", {
                key: v.vfAcutalField
              }, [
                f("img", {
                  onDblclick: (x) => T(v),
                  src: v.value,
                  class: q(["icon", { disabled: g.disabled }]),
                  draggable: "true",
                  onDragstart: (x) => y(x, v)
                }, null, 42, is)
              ]))), 128))
            ])
          ])
        ])
      ]),
      Ue(Ua, {
        ref_key: "popupEditLabelRef",
        ref: E,
        onSave: k
      }, null, 512)
    ], 4));
  }
}), ls = /* @__PURE__ */ Xt(as, [["__scopeId", "data-v-5653446d"]]), Rn = (t) => (En("data-v-43aa048c"), t = t(), Sn(), t), ss = { class: "flexi-table" }, us = { class: "table-controls" }, cs = { class: "layout-selector" }, ds = /* @__PURE__ */ Rn(() => /* @__PURE__ */ f("h4", null, "Layout: ", -1)), fs = { class: "dropdown" }, ps = ["value"], vs = { class: "quick-layouts" }, hs = ["onClick"], ms = {
  key: 0,
  class: "editor-popup"
}, gs = { class: "editor-content" }, bs = { class: "editor-header" }, ys = /* @__PURE__ */ Rn(() => /* @__PURE__ */ f("h3", null, "Tùy chỉnh bảng", -1)), ws = { class: "editor-body" }, _s = { class: "editor-actions" }, Cs = /* @__PURE__ */ Rn(() => /* @__PURE__ */ f("h4", null, "Layout:", -1)), Ds = { class: "dropdown" }, xs = ["value"], Ts = ["disabled"], Es = ["disabled"], Ss = ["disabled"], Os = /* @__PURE__ */ bt({
  __name: "FlexiTable",
  props: {
    modelValue: {},
    layouts: { default: () => [] },
    templates: { default: () => [] },
    actions: { default: () => [] },
    icons: { default: () => [] },
    data: { default: () => [] },
    height: {},
    fixed: { type: Boolean }
  },
  emits: ["update:modelValue", "onCta", "error", "save", "remove", "setDefault"],
  setup(t, { emit: e }) {
    const n = t, o = e, r = ue(!1), i = z({
      get() {
        return n.modelValue;
      },
      set(w) {
        o("update:modelValue", w);
      }
    }), a = z(() => n.layouts.find((w) => w.id === i.value)), l = (w) => {
      o("error", w);
    }, s = (w, D, S) => {
      o("onCta", w, D, S);
    }, c = ue([]), d = ue(""), u = z(() => c.value.find((w) => w.id === d.value)), y = z({
      get() {
        var w;
        return ((w = u.value) == null ? void 0 : w.columns) || [];
      },
      set(w) {
        u.value.columns = w;
      }
    }), b = () => {
      r.value = !0, d.value = i.value, c.value = JSON.parse(JSON.stringify(n.layouts || [])).map((w) => ({
        ...w,
        isSave: !0
      }));
    }, p = () => {
    }, h = () => {
      var S;
      const w = Wo(), D = {
        ...JSON.parse(JSON.stringify(u.value)),
        isSave: !1,
        isSystem: !1,
        isDefault: !1,
        id: w,
        title: `${((S = u.value) == null ? void 0 : S.title) || ""} clone`
      };
      c.value.push(D), d.value = w;
    }, m = () => {
      var S;
      const w = d.value, D = () => {
        const k = c.value.findIndex((g) => g.id === w);
        c.value.splice(k, 1), d.value = c.value[0].id || "";
      };
      (S = u.value) != null && S.isSave ? o("remove", w, () => {
        D();
      }) : D();
    }, T = () => {
      const w = JSON.parse(JSON.stringify(u.value));
      delete w.isSave, o("save", w, () => {
        u.value && (u.value.isSave = !0);
      });
    }, E = () => {
      o("setDefault", d.value, () => {
      });
    };
    return yt(() => {
    }), (w, D) => {
      var S, k, g, C, v, x, O, V;
      return L(), M("div", ss, [
        f("div", us, [
          f("div", cs, [
            ds,
            f("div", fs, [
              fe(f("select", {
                "onUpdate:modelValue": D[0] || (D[0] = (A) => i.value = A)
              }, [
                (L(!0), M(ne, null, oe(w.layouts, (A) => (L(), M("option", {
                  key: A.id,
                  value: A.id
                }, we(A.title), 9, ps))), 128))
              ], 512), [
                [Gn, i.value]
              ])
            ]),
            f("div", vs, [
              (L(!0), M(ne, null, oe(w.layouts, (A) => (L(), M("button", {
                key: A.id,
                onClick: (H) => i.value = A.id,
                class: q({ active: i.value === A.id })
              }, we(A.title), 11, hs))), 128))
            ])
          ]),
          f("div", { class: "settings" }, [
            f("button", { onClick: b }, " ⚙️ ")
          ])
        ]),
        Ue(Jn, {
          columns: ((S = a.value) == null ? void 0 : S.columns) || [],
          labels: ((k = a.value) == null ? void 0 : k.labels) || [],
          templates: [...w.templates, ...w.actions, ...w.icons],
          data: w.data,
          height: w.height,
          fixed: w.fixed,
          onOnCta: s
        }, null, 8, ["columns", "labels", "templates", "data", "height", "fixed"]),
        r.value ? (L(), M("div", ms, [
          f("div", {
            class: "editor-overlay",
            onClick: D[1] || (D[1] = (A) => r.value = !1)
          }),
          f("div", gs, [
            f("div", bs, [
              ys,
              f("button", {
                onClick: D[2] || (D[2] = (A) => r.value = !1)
              }, "✕")
            ]),
            f("div", ws, [
              Ue(Jn, {
                columns: y.value,
                labels: ((g = u.value) == null ? void 0 : g.labels) || [],
                templates: [...w.templates, ...w.actions, ...w.icons],
                data: w.data,
                height: 250,
                fixed: !0
              }, null, 8, ["columns", "labels", "templates", "data"]),
              f("div", _s, [
                Cs,
                f("div", Ds, [
                  fe(f("select", {
                    "onUpdate:modelValue": D[3] || (D[3] = (A) => d.value = A),
                    onChange: p
                  }, [
                    (L(!0), M(ne, null, oe(c.value, (A) => (L(), M("option", {
                      key: A.id,
                      value: A.id
                    }, we(A.title), 9, xs))), 128))
                  ], 544), [
                    [Gn, d.value]
                  ])
                ]),
                f("button", { onClick: h }, " Clone "),
                f("button", {
                  disabled: (C = u.value) == null ? void 0 : C.isSystem,
                  onClick: m
                }, " Xóa ", 8, Ts),
                f("button", {
                  disabled: (v = u.value) == null ? void 0 : v.isSystem,
                  onClick: T
                }, " Lưu ", 8, Es),
                f("button", {
                  disabled: !((x = u.value) != null && x.isSave) || ((O = u.value) == null ? void 0 : O.id) === i.value,
                  onClick: E
                }, " Default ", 8, Ss)
              ]),
              Ue(ls, {
                modelValue: y.value,
                "onUpdate:modelValue": D[4] || (D[4] = (A) => y.value = A),
                labels: u.value.labels,
                "onUpdate:labels": D[5] || (D[5] = (A) => u.value.labels = A),
                "vf-fields": w.templates,
                actions: w.actions,
                icons: w.icons,
                height: 450,
                disabled: (V = u.value) == null ? void 0 : V.isSystem,
                onError: l
              }, null, 8, ["modelValue", "labels", "vf-fields", "actions", "icons", "disabled"])
            ])
          ])
        ])) : Tn("", !0)
      ]);
    };
  }
}), ks = /* @__PURE__ */ Xt(Os, [["__scopeId", "data-v-43aa048c"]]);
export {
  Jn as DynamicTable,
  ks as FlexiTable,
  ls as TableEditor,
  P as VfType
};
